//PRINTOFF JOB (SYS),'INSTALL PRINTOFF',CLASS=S,MSGCLASS=X              00000100
//*                                                                     00000200
//* SOURCE: CBT (V430) FILE #325                                        00000300
//* TARGET: SYS2.CMDLIB   SYS2.HELP                                     00000400
//*                                                                     00000500
//********************************************************************* 00000600
//* This job installs the TSO PRINTOFF command and help.              * 00000700
//********************************************************************* 00000800
//*                                                                     00000900
//INSTALL PROC SOUT='*',               <=== SYSOUT CLASS                00001000
//             LIB='SYS2.CMDLIB',      <=== TARGET LOAD LIBRARY         00001100
//             HELP='SYS2.HELP',       <=== HELP LIBRARY                00001200
//             SYSTS=SYSDA,            <=== UNITNAME FOR WORK DATASETS  00001300
//             ASMBLR=IFOX00,          <=== NAME OF YOUR ASSEMBLER      00001400
//             ALIB='SYSC.LINKLIB',    <=== LOCATION OF YOUR ASSEMBLER  00001500
//             MACLIB='SYS1.MACLIB',   <=== MACLIB DATASET NAME         00001600
//             AMODGEN='SYS1.AMODGEN'  <=== AMODGEN DATASET NAME        00001700
//*                                                                     00001800
//IEBUPDTE EXEC PGM=IEBUPDTE,PARM=NEW                                   00001900
//SYSPRINT DD  SYSOUT=&SOUT                                             00002000
//SYSUT1   DD  DSN=&HELP,DISP=SHR                                       00002100
//SYSUT2   DD  DSN=&HELP,DISP=SHR                                       00002200
//*                                                                     00002300
//ASM     EXEC PGM=&ASMBLR,REGION=2048K,PARM='NOOBJECT,DECK,NOALIGN'    00002400
//STEPLIB  DD  DSN=&ALIB,DISP=SHR                                       00002500
//SYSTERM  DD  SYSOUT=&SOUT                                             00002600
//SYSPRINT DD  SYSOUT=&SOUT                                             00002700
//SYSLIB   DD  DSN=&MACLIB,DISP=SHR                                     00002800
//         DD  DSN=&AMODGEN,DISP=SHR                                    00002900
//SYSUT1   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00003000
//SYSUT2   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00003100
//SYSUT3   DD  UNIT=&SYSTS,SPACE=(TRK,(30,15))                          00003200
//SYSPUNCH DD  DSN=&&SYSLIN,UNIT=&SYSTS,DISP=(,PASS,DELETE),            00003300
//             SPACE=(TRK,(30,30))                                      00003401
//*                                                                     00003500
//DELINK  EXEC PGM=DELINKER,REGION=1024K                                00003601
//STEPLIB  DD  DISP=SHR,DSN=SYSC.LINKLIB                                00003702
//SYSPRINT DD  SYSOUT=*                                                 00003801
//SYSPUNCH DD  DSN=&&SYSLIN,DISP=MOD                                    00003901
//SYSLIB   DD  DISP=SHR,DSN=SYS1.LPALIB                                 00004001
//*                                                                     00004101
//LKED    EXEC PGM=IEWL,COND=(0,NE),PARM='LIST,MAP,XREF'                00004200
//SYSPRINT DD  SYSOUT=&SOUT                                             00004300
//SYSUT1   DD  UNIT=&SYSTS,SPACE=(TRK,10)                               00004400
//SYSLMOD  DD  DSN=&LIB,DISP=SHR                                        00004500
//SYSLIN   DD  DSN=&&SYSLIN,DISP=(OLD,DELETE)                           00004600
//         DD  DDNAME=SYSIN                                             00004700
//        PEND                                                          00004800
//*                                                                     00004900
//        EXEC INSTALL                                                  00005000
//*                                                                     00005100
//IEBUPDTE.SYSIN DD *                                                   00005200
./ ADD NAME=PRINTOFF                                                    00005300
./ ALIAS NAME=PRINTO                                                    00005400
./ ALIAS NAME=PO                                                        00005500
)F Function -                                                           00005600
   The PRINTOFF command creates a printed copy of data sets through     00005700
   foreground copying to SYSOUT.  The command prints datasets which     00005800
   are sequential or partitioned, blocked or unblocked, with fixed,     00005900
   variable, or undefined length records of any length up to 32,760.    00006000
)X Syntax -                                                             00006100
   PRINTOFF (dslist)/*  DDNAME(ddname)/FILE(ddname)                     00006200
            UNIT(unit-type)  VOLUME(volser)     NOMESSAGES/NOMSGS       00006300
            CLASS(class)     DEST(destination)  COPIES(nnn)             00006400
            HOLD/NOHOLD      LIST/NOLIST        PRINT/NOPRINT           00006500
            FORMS(form)      FCB(fcb)           TRAIN(image)/UCS(image) 00006600
            HEADING/NOHEADING                   CAPS/ASIS/FOLD/NOFOLD   00006700
            NOCC/SINGLESPACE/SS/DOUBLESPACE/DS  ASA                     00006800
            LINELENGTH(nnn)/LL(nnn)             PAGELENGTH(nnn)/PL(nnn) 00006900
            BURST/NOBURST    FLASH(flash-name)  CHARS(charset-name(s))  00007000
            PROG(progname)   UDKFONT(font-name)                         00007100
   Required -- dslist or * if DDNAME(...)                               00007200
   Aliases  -- PRINTO, PO                                               00007300
   Defaults -- CLASS(A), COPIES(1), NOHOLD, LIST, PRINT, FORM($TST),    00007400
               HEADING, ASIS, LINELENGTH(132), PAGELENGTH(60), NOBURST, 00007500
               SINGLESPACE if PAGELENGTH(...) or if input RECFM not A/M 00007600
)O Operands -                                                           00007700
)P DSLIST - Data set list contains the names of data sets to be printed 00007800
            or punched.  The names should follow TSO convention, in     00007900
            quotes if the primary index differs from your profile       00008000
            prefix, or without quotes and with the primary index        00008100
            omitted if it is the same as your profile prefix.           00008200
            Enclosing parenthesis are required if there is more than    00008300
            one name in the list.                                       00008400
              If DDNAME(...) is specified, the dslist must end with an  00008500
            asterisk (or contain only an asterisk) as a place holder.   00008600
))ASA     - Output is to be printed using input data column 1 as ASA    00008700
            carriage control characters even though the DCB record      00008800
            format does not specify RECFM=..A                           00008900
))ASIS    - Output is not to be converted to upper case prior to        00009000
            printing. (It is left as it is.)                            00009100
            NOFOLD is an alias for ASIS.                                00009200
))BURST   - Output is to be trimmed and burst. ===> VALID FOR 3800 ONLY 00009300
))NOBURST - Output will be printed on continuous forms.                 00009400
))CAPS    - Output is to be converted to upper case prior to            00009500
            printing. FOLD is an alias for CAPS.                        00009600
))CHARS(charset-name(s)) - Character set(s) to be used to print the     00009700
            output. (1-4 names, each name 1-4 characters.)  If more     00009800
            than one character set name is given, the input data should 00009900
            have the character set id specified in the second character 00010000
            of each line. OPTCD=J is assumed. See the JCL reference     00010100
            manual for more information. ===> VALID FOR 3800 ONLY       00010200
))CLASS(class) - SYSOUT class in which output is to be printed.         00010300
            Default is A.                                               00010400
))COPIES(nnn) - Number of copies to be printed.  Default is 1.          00010500
))DEST(destination) - The destination to where SYSOUT is to be routed.  00010600
            Destination can be a JES remote line, a JES local or remote 00010700
            printer, or a network node and userid. Local and remote     00010800
            names are 1-8 characters. Network names are 3-17 characters 00010900
            (node.userid) with the period required as a separator.      00011000
            DEST(node.userid) is mutually exclusive with                00011100
            PROG(progname).                                             00011200
))DDNAME(ddname) - DD name of a previously allocated dataset. If DDNAME 00011300
            is specified, the last (or only) dataset name in dslist     00011400
            must be an asterisk. The DD will not be freed after being   00011500
            printed. FILE is an alias for DDNAME.                       00011600
))FCB(fcb) - Forms Control Buffer to be used when the data set is       00011700
            printed.  (1-4 character FCB name)                          00011800
))FLASH(flashname) - The name of the forms flash overlay which is to be 00011900
            flashed on all output. ===> VALID FOR 3800 ONLY             00012000
))FORMS(form) - Form to be used when the data set is printed.           00012100
            Default is $TST. (1-4 character form name)                  00012200
))HEADING - Output is to have a heading containing the data set name.   00012300
))NOHEADING - Output is not to have heading information.                00012400
))HOLD    - Output is to be placed on a hold queue upon deallocation.   00012500
))NOHOLD  - Output is not to be placed on a hold queue upon             00012600
            deallocation.                                               00012700
))LINELENGTH(nnn) - Number of characters on each line of printed        00012800
            output. (1-208 characters with a default of 132.)  Input    00012900
            lines longer than specified linelength will be printed on   00013000
            multiple lines.  LL(...) is an alias for LINELENGTH(...).   00013100
))LIST    - A separate listing of member names processed is to be       00013200
            created and printed with the data set output.               00013300
))NOLIST  - No list of member names is to be created.                   00013400
))NOMESSAGES - Non-error messages are not to be written to the TSO      00013500
            terminal. NOMSGS is an alias of NOMESSAGES. The default is  00013600
            to write informational messages to the terminal before and  00013700
            after printing.                                             00013800
))PAGELENGTH(nnn) - Number of lines per page.  (1-120 lines with a      00013900
            default of 60.)  Carriage control in input records is       00014000
            ignored (even if ASA is specified) and SINGLESPACE is used. 00014100
            PL(...) is an alias for PAGELENGTH(...).                    00014200
))PRINT   - Members are to be printed. (Whether they are also listed    00014300
            is controlled by LIST/NOLIST.)                              00014400
))NOPRINT - Members are not to be printed. (Whether they are to be      00014500
            listed is controlled by LIST/NOLIST.)                       00014600
))PROG(progname) - The name of the special 'external writer' program    00014700
            that is to process the output. PROG(progname) is mutually   00014800
            exclusive with DEST(node.userid).                           00014900
))TRAIN(image) - Print image to be used when the data set is printed.   00015000
            UCS is an alias for TRAIN. (1-4 character print image name) 00015100
))UCS(image) - Print image to be used when the data set is printed.     00015200
            UCS is an alias for TRAIN. (1-4 character print image name) 00015300
))SINGLESPACE - Output is to be single spaced.  Carriage control in     00015400
            input data is ignored even if ASA is specified.             00015500
            NOCC and SS are aliases for SINGLESPACE.                    00015600
))DOUBLESPACE - Output is to be double spaced between lines.  Carriage  00015700
            control in input data is ignored even if ASA is specified.  00015800
            DS is an alias for DOUBLESPACE.  (Multiple line records     00015900
            will not be split between pages.)                           00016000
))UNIT(unit-type) - Unit type of the specified VOLUME(volser). UNIT is  00016100
            ignored if VOLUME is not also specified. UNIT is required   00016200
            only when the dataset is not cataloged, or when the dataset 00016300
            is cataloged to a different volume than the specified       00016400
            VOLUME and the volume cannot be accessed through your TSO   00016500
            default unit type.                                          00016600
))VOLUME(volser) - Volume serial of volume on which data sets to be     00016700
            printed are found.  This volume serial will be used for all 00016800
            data sets specified in the data set list.                   00016900
))UDKFONT(font-name) - Output is intended to be printed on a XEROX 2700 00017000
            or 3700.  PRINTOFF will insert Xerox User Defined Key (UDK) 00017100
            statements in the output to select the specified font.  No  00017200
            validation is performed on the font name before it is sent  00017300
            to the printer, so the full font name must be specified in  00017400
            upper/lower case exactly as expected by the XEROX printer.  00017500
            (PRINTOFF uses the left brace character, {, hex C0, as the  00017600
            UDK.  Input data containing this character will be          00017700
            interpreted by the printer as a Xerox command, and may      00017800
            produce undesired results.)                                 00017900
/*                                                                      00018000
//*----------------------------------------------------------- IEBUPDTE 00018100
//ASM.SYSIN DD *                                                        00018200
*                                                                       00018300
*  NOTE TO FUTURE ASSEMBLERS ... PRINTOFF NORMALLY RESIDES IN           00018400
*  A LINKLIB WITH  A L I A S E S  PRINTO AND PO.                        00018500
*  THE HELP ENTRY SHOULD BE ASSIGNED THE SAME ALIASES.                  00018600
*                                                                       00018700
PRINTOFF TITLE 'IPO-SUPPLIED PRINT COMMAND - MODIFIED BY GTEL, ARAMCO, C00018800
               WFB      '                                           WFB 00018900
*********************************************************************** 00019000
*                                                                     * 00019100
*             MODULE NAME = PRINTOFF                                  * 00019200
*                                                                     * 00019300
*             DESCRIPTIVE NAME =  IPO SUPPLIED PRINT COMMAND FOR      * 00019400
*                TSO FOREGROUND EXECUTION                             * 00019500
*                                                                     * 00019600
*             COPYRIGHT = NONE                                        * 00019700
*                                                                     * 00019800
*             STATUS = RELEASE 01.0 OF IPO                            * 00019900
*                                                                     * 00020000
*             FUNCTION =                                              * 00020100
*                PRINTS A DATASET(S) WHICH IS SEQUENTIAL OR PARTIONED * 00020200
*                ALLOWING THE USER TO SPECIFY OUTPUT CLASS, COPIES,   * 00020300
*                DESTINATION AND HOLD/NOHOLD.  ALSO ALLOWS THE USER   * 00020400
*                TO SPECIFY LIST/NOLIST, PRINT/NOPRINT, VOLUME,       * 00020500
*                FOLD/NOFOLD, DS/SS, LINELENGTH AND PAGELENGTH     GTEL 00020600
*                LIST IF PDS MEMBER NAMES ARE ONLY TO BE LISTED.      * 00020700
*                PRINT IF PDS MEMBERS ARE ONLY TO BE PRINTED.         * 00020800
*                SEE 'CHANGE ACTIVITY' FOR ADDITIONAL OPTIONS.      WFB 00020900
*                                                                     * 00021000
*                OPERATION =                                          * 00021100
*                   BUILD PARS, DAIR, AND PUTLINE PARAMETER LISTS.    * 00021200
*                   CALL PARS TO PARSE COMMAND BUFFER.                * 00021300
*                   ALLOCATE DATASET AND DETERMINE IF PDS OR          * 00021400
*                      SEQUENTIAL.                                    * 00021500
*                   DETERMINE WHAT FUNCTIONS WERE TO BE PERFORMED     * 00021600
*                      FOR THIS DATASET IF PDS.                       * 00021700
*                   ALLOCATE SYSOUT DATASETS WHEN SOMETHING IS        * 00021800
*                      FOUND TO BE PRINTED.                           * 00021900
*                   PROCESS NEXT DATASET IN LIST.                     * 00022000
*                   AT END OF LIST CLOSE DATASETS AND FREE ANY        * 00022100
*                      SYSOUT DATASETS AND INPUT DATASETS.         GTEL 00022200
*                   DATSETS WILL BE PRINTED AS EITHER VBA OR VBM.     * 00022300
*                                                                     * 00022400
*              NOTES =                                                * 00022500
*                                                                     * 00022600
*                 DEPENDENCIES = CHARACTER SET IS EBCDIC.  REASSEMBLE * 00022700
*                    IF A DIFFERENT CHARACTER SET IS NEEDED.          * 00022800
*                                                                     * 00022900
*                                                                     * 00023000
*                 RESTRICTIONS = DATASETS MUST HAVE LRECL NOT       WFB 00023100
*                    GREATER THAN 32,760 AND MUST NOT               WFB 00023200
*                    CONTAIN SPANNED RECORDS.  IN ADDITION,        GTEL 00023300
*                    IF PAGELEN, DS, OR SS IS SPECIFIED, ALL       GTEL 00023400
*                    OTHER CARRIAGE CONTROL WILL BE IGNORED.       GTEL 00023500
*                                                                     * 00023600
*                 REGISTER CONVENTIONS = STANDARD CONVENTIONS.        * 00023700
*                    REGISTERS 0 TO 10 = WORK REGISTERS               * 00023800
*                    REGISTERS 11,12   = ADDRESSIBILITY TO         GTEL 00023900
*                                        PRINTOFF CSECT            GTEL 00024000
*                    REGISTER  13      = SAVE AREA REGISTER AND       * 00024100
*                                        ADDRESSABILITY TO GETMAINED  * 00024200
*                                        WORK AREA                    * 00024300
*                    REGISTERS 14,15   = WORK REGISTERS               * 00024400
*                                                                     * 00024500
*                PATCH LABEL = PATCH, UNUSED AND INTIALIZED TO        * 00024600
*                   DC 20S(*)                                      WFB* 00024700
*                                                                     * 00024800
*                TSO COMMAND SYNTAX                                 WFB 00024900
* PRINTOFF (DSLIST)/*  DDNAME(DDNAME)/FILE(DDNAME)                    * 00025000
*          UNIT(UNIT-TYPE)  VOLUME(VOLSER)     NOMESSAGES/NOMSGS      * 00025100
*          CLASS(CLASS)     DEST(DESTINATION)  COPIES(NNN)            * 00025200
*          HOLD/NOHOLD      LIST/NOLIST        PRINT/NOPRINT          * 00025300
*          FORMS(FORM)      FCB(FCB)           TRAIN(IMAGE)/UCS(IMAGE)* 00025400
*          HEADING/NOHEADING                   CAPS/ASIS/FOLD/NOFOLD  * 00025500
*          NOCC/SINGLESPACE/SS/DOUBLESPACE/DS  ASA                    * 00025600
*          LINELENGTH(NNN)/LL(NNN)             PAGELENGTH(NNN)/PL(NNN)* 00025700
*          BURST/NOBURST    FLASH(FLASH-NAME)  CHARS(CHARSET-NAME(S)) * 00025800
*          PROG(PROGNAME)   UDKFONT(FONT-NAME)                        * 00025900
* REQUIRED -- DSLIST OR * IF DDNAME(...)                              * 00026000
* ALIASES  -- PRINTO, PO                                              * 00026100
* DEFAULTS -- CLASS(A), COPIES(1), NOHOLD, LIST, PRINT, FORM($TST),   * 00026200
*             HEADING, ASIS, LINELENGTH(132), PAGELENGTH(60), NOBURST,* 00026300
*             SINGLESPACE IF PAGELENGTH(...) OR IF INPUT RECFM NOT A/M* 00026400
*                                                                     * 00026500
*             MODULE TYPE = PROCEDURE                                 * 00026600
*                                                                     * 00026700
*                PROCESSOR = ASM                                      * 00026800
*                                                                     * 00026900
*                MODULE SIZE = 13K BYTES                              * 00027000
*                                                                     * 00027100
*                ATTRIBUTES = SCHEDULER KEY 8, REENTRANT,             * 00027200
*                   PROBLEM PROGRAM STATE                             * 00027300
*                                                                     * 00027400
*             ENTRY POINTS = PRINTOFF (ONLY ENTRY POINT)              * 00027500
*                                                                     * 00027600
*                LINKAGE =                                            * 00027700
*                   FROM TERMINAL MONITOR PROGRAM AS A COMMAND        * 00027800
*                                                                     * 00027900
*             INPUT = REGISTER 1 POINTS TO COMMAND PROCESSOR          * 00028000
*                PARAMETER LIST MAPPED BY IKJCPPL MACRO               * 00028100
*                                                                     * 00028200
*             OUTPUT = NONE                                           * 00028300
*                                                                     * 00028400
*             EXIT - NORMAL = AT PROGRAM END VIA BRANCH REGISTER 14   * 00028500
*                                                                     * 00028600
*                OUTPUT = NONE                                        * 00028700
*                                                                     * 00028800
*                RETURN CODE = ZERO                                   * 00028900
*                                                                     * 00029000
*             EXIT - ERROR = NONE - PROGRAM WILL DISPLAY DECIMAL      * 00029100
*                RETURN CODE AND RETURN VIA BRANCH REGISTER 14        * 00029200
*                                                                     * 00029300
*                OUTPUT = NONE                                        * 00029400
*                                                                     * 00029500
*                RETURN CODE = ZERO                                   * 00029600
*                                                                     * 00029700
*             EXTERNAL REFERENCES =                                   * 00029800
*                                                                     * 00029900
*                ROUTINES = IKJPARS, DAIRFAIL, GNRLFAIL, PUTLINE      * 00030000
*                   IKJEFLPA  (SEE NOTE IN 'CHANGE ACTIVITY')       WFB 00030100
*                                                                     * 00030200
*                DATA AREAS = NONE                                    * 00030300
*                                                                     * 00030400
*                CONTROL BLOCKS = CPPL, PPL, DAPL, DCB, DAPB, CVT,    * 00030500
*                   S99RBP, S99RB, S99TUPL, S99TUNIT, S99TUFLD,       * 00030600
*                   GFPARMS, DFPARMS, IOPL, IOPB                      * 00030700
*                                                                     * 00030800
*             TABLES = DATA AREA TO BE GETMAINED.  MAPPED BY DSECT    * 00030900
*                BEGINNING AT LABEL WORKAREA                        WFB 00031000
*                                                                     * 00031100
*             MACROS = SAVE, GETMAIN, CALLTSSR, LINK, TPUT, FREEMAIN, * 00031200
*                   OPEN, PUT, GET, CLOSE, RDJFCB, IKJRLSA, DYNALLOC, * 00031300
*                   DCB, IKJPARM, IKJPOSIT, IKJKEYWD, IKJNAME,        * 00031400
*                   IKJSUBF, IKJIDENT, IKJENDP, IKJDAP08, IKJDAP18,   * 00031500
*                   IKJDAPL, IKJCPPL, IKJPPL, CVT, IEFZB4D0, IKJIOPL, * 00031600
*                   IEFZB4D2, DCBD, IKJEFFGF, IKJEFFDF, PUTLINE       * 00031700
*                                                                     * 00031800
*             CHANGE ACTIVITY = 3800 SUPPORT ADDED VIA SETPRT   ARAMCO* 00031900
*                               MAY 1981                        ARAMCO* 00032000
*                                                                     * 00032100
*             MODIFIED BY SAM LEPORE, WFB: 01/86                    WFB 00032200
*               * CORRECT ERROR, 'NOHEAD' CAUSED BLANK FIRST PAGE   WFB 00032300
*               * CORRECT ERRORS IN LENGTH OF TEXTG THROUGH TEXTJ   WFB 00032400
*               * INCREASE INPUT RECORD LIMIT TO 32,760             WFB 00032500
*               * CHANGE DSNAME POSIT TO DSTHING TO ALLOW FOR DDN() WFB 00032600
*               * CHANGE DEST KEYWORD TO ACCEPT 8 CHAR VALUE        WFB 00032700
*               * CHANGE DEST KEYWORD TO ACCEPT NODE AND USERID     WFB 00032800
*               * ADD DDNAME(...) KEYWORD TO ALLOW TEMP OR VIO DSNS WFB 00032900
*               * ADD UNIT(...) KEYWORD FOR USE WITH VOLUME(...)    WFB 00033000
*               * ADD 'VOLUME: VOLSER' TO HEADING WHEN SPECIFIED    WFB 00033100
*    +--------> * ADD TIME AND 'MONTHNAME DAY, YEAR' TO DSN HEADING WFB 00033200
*    :          * ADD NOMSGS KEYWORD TO STOP NON-ERROR MSGS TO TERM WFB 00033300
*    :          * ADD DSECT=YES TO CVT MACRO FOR CLEAN XA ASSEMBLY  WFB 00033400
*    :          * MOVE ALL PUTLINE TEXT TO SEPARATE MESSAGES CSECT  WFB 00033500
*    :                (FOLLOWING CHANGES ARE WFB SPECIFIC)          WFB 00033600
*    :          * MAKE WFB DEFAULT FORM($TST)                       WFB 00033700
*    :                                                              WFB 00033800
*    +-- NOTE ==> THE TIME-DATE ROUTINE IKJEFLPA NORMALLY RESIDES   WFB 00033900
*                 ONLY IN SYS1.AOST4. THIS LIBRARY MUST BE INCLUDED WFB 00034000
*                 IN THE LINKEDIT SYSLIB FOR PROPER RESOLUTION.     WFB 00034100
*    05/20/2024 -> INSERT DELINKER STEP TO EXTRACT OBJECT FOR       JLM 00034201
*                  IKJEFLPA & IKJEFLPB FROM SYS1.LPALIB. THIS       JLM 00034301
*                  ENSURES CURRENT VERSION OF TIME-DATE ROUTINE     JLM 00034401
*                  IS USED.                                         JLM 00034501
*                                                                   WFB 00034600
*             MODIFIED BY SAM LEPORE, WFB: 01/87                    WFB 00034700
*                                                                   WFB 00034800
*               * CORRECT ERROR, 'NOHEAD' OFFSET LINE COUNT PAGE 1  WFB 00034900
*               * ADD ASA KEYWORD TO ACCEPT CC WHEN RECFM NOT ..A   WFB 00035000
*               * ADD NOCC KEYWORD ALIAS OF SINGLESPACE             WFB 00035100
*               * ADD UDKFONT(...) KEYWORD FOR XEROX 2700/3700 FONT WFB 00035200
*               * DELETE OLD LINES MARKED *DELETED OR 'DELETED CODE'WFB 00035300
*                                                                     * 00035400
*                                                                     * 00035500
*             MESSAGES =                                              * 00035600
*                                                                     * 00035700
*                BOTH THE DARIFAIL AND GNRLFAIL SERVICE ROUTINES ARE  * 00035800
*                USED TO ISSUE MESSAGES.                              * 00035900
*                THOSE ISSUED BY THE COMMAND ARE FOUND FOLLOWING THE  * 00036000
*                LABEL GNRLERR AND ARE ISSUED USING PUTLINE.          * 00036100
*                                                                     * 00036200
*             ABEND CODES = NONE                                      * 00036300
*                                                                     * 00036400
*********************************************************************** 00036500
*                                                                       00036600
PRINTOFF CSECT                                                          00036700
R0       EQU   0                                                        00036800
R1       EQU   1                                                        00036900
R2       EQU   2                                                        00037000
R3       EQU   3                                                        00037100
R4       EQU   4                                                        00037200
R5       EQU   5                                                        00037300
R6       EQU   6                                                        00037400
R7       EQU   7                                                        00037500
R8       EQU   8                                                        00037600
R9       EQU   9                                                        00037700
R10      EQU   10                                                       00037800
R11      EQU   11                                                       00037900
R12      EQU   12                                                       00038000
R13      EQU   13                                                       00038100
R14      EQU   14                                                       00038200
R15      EQU   15                                                       00038300
         SAVE  (14,12),,HARDCOPY.IPO.&SYSTIME_&SYSDATE SAVE REGISTERS   00038400
         LR    R12,R15                 LOAD REGISTER 12 WITH ENTRY      00038500
*                                      ADDRESS                          00038600
         USING PRINTOFF,R12            ESTABLISH ADDRESSABILITY TO      00038700
*                                      PROGRAM CSECT                    00038800
         LA    R11,4095(R12)           LOAD REGISTER 11 WITH ENTRY      00038900
*                                      ADDRESS 4095                     00039000
         USING PRINTOFF+4095,R11       ESTABLISH ADDRESSABILITY TO THE  00039100
*                                      REST OF THE PROGRAM CSECT        00039200
         LR    R8,R1                   LOAD REGISTER 8 TO PRESERVE      00039300
*                                      POINTER TO COMMAND PROCESSOR     00039400
*                                      PARAMETER LIST                   00039500
         GETMAIN R,LV=LDYNAMIC         GETMAIN DYNAMIC WORKAREA         00039600
         LR    R10,R1                  LOAD REGISTER 10 TO PRESERVE     00039700
*                                      POINTER TO WORKAREA              00039800
         ST    R13,4(R10)              STORE ADDRESS OF PREVIOUS        00039900
*                                      SAVEAREA                         00040000
         ST    R10,8(,R13)             STORE ADDRESS OF CURRENT         00040100
*                                      SAVEAREA IN PREVIOUS SAVEAREA    00040200
         LR    R13,R10                 LOAD REGISTER 13 WITH ADDRESS OF 00040300
*                                      CURRENT SAVEAREA                 00040400
         USING WORKAREA,R13            ESTABLISH ADDRESSABILITY TO      00040500
*                                      DYNAMIC WORKAREA                 00040600
         GETMAIN R,LV=RECSIZE          GETMAIN RECORD AREA          WFB 00040700
         ST    R1,ALNDSECT             SAVE ADDRESS OF RECORD      GTEL 00040800
*                                                                       00040900
*********************************************************************** 00041000
*                                                                     * 00041100
*        BUILD PARSE AND DAIR PARAMETER LISTS USING COMMAND           * 00041200
*           PROCESSOR PARAMETER LIST                                  * 00041300
*        INITIALIZE OUTPUT DATA CONTROL BLOCKS IN WORKAREA            * 00041400
*                                                                     * 00041500
*********************************************************************** 00041600
*                                                                       00041700
         USING CPPL,R8                 ESTABLISH ADDRESSABILITY TO CPPL 00041800
         LA    R4,PPLSECT              LOAD ADDRESS OF PARSE PARAMETER  00041900
*                                      LIST                             00042000
         USING PPL,R4                  ESTABLISH ADDRESSABILITY TO PPL  00042100
         LA    R6,DAPLSECT             LOAD ADDRESS OF DAIR PARAMETER   00042200
*                                      LIST                             00042300
         USING DAPL,R6                 ESTABLISH ADDRESSABILITY TO DAPL 00042400
         LA    R5,IOPLSECT             LOAD ADDRESS OF PUTLINE          00042500
*                                      PARAMETER LIST                   00042600
         USING IOPL,R5                 ESTABLISH ADDRESSABILITY TO IOPL 00042700
         L     R1,CPPLUPT              LOAD POINTER TO USER PROFILE     00042800
*                                      TABLE FROM CPPL                  00042900
         L     R2,CPPLECT              LOAD POINTER TO ENVIRONMENT      00043000
*                                      CONTROL TABLE FROM CPPL          00043100
         SLR   R3,R3                   ZERO REGISTER 3                  00043200
         ST    R3,ECB                  STORE REGISTER AS ECB FOR PPL    00043300
         LA    R3,ECB                  LOAD ADDRESS OF ECB              00043400
         STM   R1,R3,DFPLSECT          STOR UPT,ECT,ECB IN DFPL    GTEL 00043500
         STM   R1,R3,PPLSECT           STORE ADDRESS OF UPT, ECT, AND   00043600
*                                      ECB IN PPL                       00043700
         STM   R1,R3,DAPLSECT          STORE ADDRESS OF UPT, ECT, AND   00043800
*                                      ECB IN DAPL                      00043900
         STM   R1,R3,IOPLSECT          STORE ADDRESS OF UPT, ECT, AND   00044000
*                                      ECB IN IOPL                      00044100
         LA    R3,IOPB                 LOAD ADDRESS OF PUTLINE          00044200
*                                      PARAMETER BLOCK                  00044300
         ST    R3,IOPLIOPB             STORE IOPB ADDRESS IN IOPL       00044400
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00044500
**************************** START OF GTEL MOD ************************ 00044600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00044700
*   INITIALIZE DFPL AND DFPB SO REST OF NAME CAN BE DETERMINED          00044800
         LA    R3,DFPBSECT             GET ADDRESS OF DFPB              00044900
         ST    R3,DFPLSECT+12          PUT IT IN THE CNTL BLK           00045000
         USING  DFPB,R3                TELL ASSEMBLER                   00045100
         LA     R2,DFPBDSL             GET ADDRESS OF DSN LENGTH        00045200
         ST     R2,DFPBDSN             SAVE IT                          00045300
         LA     R2,DFPBQUA             GET ADDRESS OF QUAL              00045400
         ST     R2,DFPBQUAL            STORE IT                         00045500
         MVI    DFPBCODE,DFPB04        MOVE IN TYPE                     00045600
         MVC    DFPBPSCB,CPPLPSCB      MOVE IN PSCB ADDRESS             00045700
         MVI    DFPBCNTL,DFPBRET       MOVE IN DFPBRET                  00045800
         XC     DFPBCAT(8),DFPBCAT     CLEAR AREA                       00045900
         DROP    R3                                                     00046000
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00046100
**************************** END OF GTEL MOD ************************** 00046200
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00046300
         MVC   PPLPCL,PCLADDR          MOVE POINTER TO PARAMETER        00046400
*                                      CONTROL LIST INTO PPL            00046500
         LA    R2,PARSBACK             LOAD ADDRESS OF FULLWORD TO      00046600
*                                      CONTAIN ADDRESS OF PDE RETURNED  00046700
*                                      BY PARS                          00046800
         ST    R2,PPLANS               STORE POINTER TO RETURN ADDRESS  00046900
         MVC   PPLCBUF,CPPLCBUF        MOVE POINTER TO COMMAND BUFFER   00047000
*                                      INTO PPL                         00047100
*DELETED LA    R2,PPLUWA               LOAD ADDR OF USER WORK AREA  WFB 00047200
*DELETED ST    R2,PPLUWA               STORE ADDRESS IN PPL         WFB 00047300
         ST    R13,PPLUWA              PASS THE DYNAMIC WORK AREA   WFB 00047400
*                                      TO PARSE VALIDITY CHECK RTNE WFB 00047500
         MVC   DAPLPSCB,CPPLPSCB       MOVE POINTER TO PSCB INTO DAPL   00047600
         DROP  R4,R5,R6,R8             DROP ADDRESSABILITY TO CPPL,     00047700
*                                      IOPL, DAPL, AND PPL              00047800
         MVC   OUTPUTA(OUTPUTAL),OUTPUTAC  MOVE ASA DCB CONSTANT INTO   00047900
*                                      ASA DCB IN WORKAREA              00048000
         MVC   OUTPUTM(OUTPUTML),OUTPUTMC  MOVE MACHINE DCB CONSTANT    00048100
*                                      INTO MACHINE DCB IN WORKAREA     00048200
*                                                                       00048300
*********************************************************************** 00048400
*                                                                     * 00048500
*        CALLTSSR TO PARSE (ENTRY NAME IKJPARS)                       * 00048600
*        ON RETURN PARSBACK -> PDL                                    * 00048700
*        HANDLE ALL ERROR CODES RETURNED BY PARS                      * 00048800
*        IF NECESSARY CALL GENERAL FAIL SERVICE ROUTINE               * 00048900
*                                                                     * 00049000
*********************************************************************** 00049100
*                                                                       00049200
         CALLTSSR  EP=IKJPARS,MF=(E,PPLSECT)                            00049300
*                                      CALL PARS TO PARSE COMMAND       00049400
         LTR   R15,R15                 SEE IF RETURN CODE IS ZERO       00049500
         BZ    GOODPARS                YES....GO TO GOOD PARS ROUTINE   00049600
         C     R15,FULL4               SEE IF RETURN CODE IS FOUR       00049700
         BE    RETURN                  YES....PARS ISSUED ERROR         00049800
*                                      MESSAGE.  GO CLEANUP AND RETURN  00049900
         C     R15,FULL20              SEE IF RETURN CODE IS TWENTY     00050000
         BE    RETURN                  YES....VALIDITY CHECKING         00050100
*                                      ROUTINE ISSUED ERROR MESSAGE.    00050200
*                                      GO CLEANUP AND RETURN            00050300
         XC    GFPARMS(GFLENGF),GFPARMS  INITIALIZE PARMLIST FOR        00050400
*                                      GENERAL FAIL TO ZEROS            00050500
         LA    R1,GFPARMS              LOAD ADDRESS OF PARMLIST         00050600
         ST    R1,GFPARMP              STORE ADDRESS AS POINTER TO      00050700
*                                      PARMLIST                         00050800
         ST    R15,GFRCODE             STORE RETURN CODE IN PARMLIST    00050900
         LA    R1,GFPARSE              LOAD CALLER ID FOR PARS          00051000
         STH   R1,GFCALLID             STORE CALLER ID IN PARMLIST      00051100
         L     R1,SAVEAREA+4           LOAD ADDRESS OF PEVIOUS          00051200
*                                      SAVEAREA                         00051300
         L     R1,24(R1)               LOAD POINTER TO CPPL             00051400
         ST    R1,GFCPPLP              STORE POINTER TO CPPL IN         00051500
*                                      PARMLIST                         00051600
         LA    R1,ECB                  LOAD ADDRESS OF OPTIONAL ECB     00051700
         ST    R1,GFECBP               STORE POINTER TO ECB IN          00051800
*                                      PARMLIST                         00051900
         SLR   R1,R1                   ZERO REGISTER 1                  00052000
         ST    R1,ECB                  SET OPTIONAL ECB TO ZERO         00052100
         LINK  EP=IKJEFF19,MF=(E,GFPARMP)  LINK TO GENERAL FAIL SERVICE 00052200
*                                      ROUTINE TO HANDLE RETURN CODE    00052300
         LTR   R15,R15                 SEE IF RETURN CODE IS ZERO       00052400
         BZ    RETURN                  YES....GO CLEANUP AND RETURN     00052500
         LR    R8,R15                  LOAD REGISTER 8 WITH RETURN      00052600
*                                      CODE                             00052700
         BAL   R14,SETCODE             GO CONVERT CODE TO DECIMAL       00052800
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00052900
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00053000
         PUTLINE OUTPUT=(GNRLERR,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT  00053100
*                                      GENERAL FAIL ERROR MESSAGE       00053200
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00053300
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00053400
         PUTLINE OUTPUT=(RETNCD,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT   00053500
*                                      DECIMAL RETURN CODE              00053600
         DROP  R15                                                  WFB 00053700
         B     RETURN                  GO CLEANUP AND RETURN            00053800
*                                                                       00053900
*********************************************************************** 00054000
*                                                                     * 00054100
*        SET UP ADDRESSABILITY TO PDL                                 * 00054200
*           AND LOAD REGISTER 6 WITH ADDRESS OF DSNAME PDE            * 00054300
*                                                                     * 00054400
*********************************************************************** 00054500
*                                                                       00054600
GOODPARS DS    0H                                                       00054700
         L     R9,PARSBACK             LOAD POINTER TO PARS ANSWER      00054800
         USING IKJPARMD,R9             ESTABLISH ADDRESSABILITY TO PDL  00054900
         LA    R6,DSNAMES              LOAD POINTER TO DSNAME LIST      00055000
         MVI   VOLBIT,BLANK            BLANK OUT THE VOLUME WORK AREA   00055100
         MVC   VOLUME,VOLBIT           CONTINUE BLANKING THE VOLUME     00055200
         MVC   VOLHEAD,BLANKS          BLANK OUT THE HEADING CONST  WFB 00055300
         MVC   VOLNAME,BLANKS          BLANK OUT THE HEADING VOLUME WFB 00055400
         MVC   UNIT,BLANKS             BLANK OUT THE UNIT WORK AREA WFB 00055500
         CLC   PNOMSG(2),HALF1         SEE IF NOMSG SPECIFIED       WFB 00055600
         BNE   CHKDSN                  NO, GO SEE IF DSNAME GIVEN   WFB 00055700
         OI    VOLBIT,NOMSG            YES, TURN ON FLAG FOR LATER  WFB 00055800
CHKDSN   DS    0H                                                   WFB 00055900
         L     R1,0(,R6)               GET ADDRESS OF DSNAME        WFB 00056000
         CLI   0(R1),C'*'              SEE IF DSNAME IS ASTERISK    WFB 00056100
         BNE   CHKVSER                 NO, GO SEE IF VOLUME GIVEN   WFB 00056200
         CLC   PDDNAME(2),HALF1        SEE IF DDNAME SPECIFIED      WFB 00056300
         BE    CHKFOLD                 YES, SKIP UNIT VOL, CHK FOLD WFB 00056400
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00056500
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00056600
         PUTLINE OUTPUT=(NODSNDD,SINGLE,DATA),MF=(E,IOPLSECT)       WFB 00056700
*                                      NO DSN OR DD GIVEN MESSAGE   WFB 00056800
         DROP  R15                                                  WFB 00056900
         B     RETURN                                               WFB 00057000
CHKVSER  DS    0H                                                   WFB 00057100
         CLC   PVOL(2),HALF1           SEE IF VOLUME SPECIFIED          00057200
         BNE   CHKFOLD                 NO.....GO SEE IF FOLD IS DESIRED 00057300
         L     R7,SVOL                 LOAD POINTER TO VOLUME           00057400
         LH    R8,SVOL+4               LOAD LENGTH OF VOLUME            00057500
         BCTR  R8,0                    DECREMENT LENGTH FOR EXECUTE OF  00057600
*                                      MOVE                             00057700
         EX    R8,MOVEVOL              MOVE VOLUME INTO WORK AREA       00057800
         OI    VOLBIT,HIGH             INDICATE VOLUME PRESENT          00057900
         MVC   VOLHEAD,VOLCONST        MOVE '   VOLUME: ' TO HEAD   WFB 00058000
         MVC   VOLNAME,VOLUME          MOVE VOLUME SER TO HEADING   WFB 00058100
         CLC   PUNIT(2),HALF1          SEE IF UNIT SPECIFIED        WFB 00058200
*                                 ===> O N L Y  IF VOLUME SPECIFIED WFB 00058300
         BNE   CHKFOLD                 NO,GO SEE IF FOLD IS DESIRED WFB 00058400
         L     R7,SUNIT                LOAD POINTER TO UNIT         WFB 00058500
         LH    R8,SUNIT+4              LOAD LENGTH OF UNIT          WFB 00058600
         BCTR  R8,0                    DECREMENT LENGTH FOR EXECUTE WFB 00058700
         EX    R8,MOVEUNIT             MOVE UNIT INTO WORK AREA     WFB 00058800
         OI    VOLBIT,MID1             INDICATE UNIT PRESENT        WFB 00058900
CHKFOLD  DS    0H                                                       00059000
         CLC   PFOLD(2),HALF1          SEE IF FOLD SPECIFIED            00059100
         BNE   CHKHEAD                 NO.....GO LOOP THROUGH DSNS GTEL 00059200
         OI    VOLBIT,LOW              INDICATE FOLD PRESENT            00059300
CHKHEAD  DS    0H                                                       00059400
         CLC   PHEAD(2),HALF1          SEE IF NOHEAD SPECIFIED          00059500
         BNE   NEXT                    NO.....GO LOOP THROUGH DSNAMES   00059600
         OI    VOLBIT,MID2             INDICATE NOHEAD PRESENT     GTEL 00059700
         DROP  R9                      DROP ADDRESSABILITY TO PDL       00059800
*                                                                       00059900
*********************************************************************** 00060000
*                                                                     * 00060100
*        LOOP THROUGH DSNAME LIST RETURNED BY PARS                    * 00060200
*                                                                     * 00060300
*********************************************************************** 00060400
*                                                                       00060500
NEXT     DS    0H                                                       00060600
         LA    R1,PRINTI               LOAD POINTER TO DDNAME TO BE     00060700
*                                      FREED                            00060800
         BAL   R2,FREEDD               BRANCH TO FREE ROUTINE           00060900
         LTR   R8,R8                   SEE IF RETURN CODE FROM FREE IS  00061000
*                                      ZERO                             00061100
         BNZ   CLOSDCBS                NO.....GO CLOSE DCBS AND RETURN  00061200
         L     R5,0(R6)                LOAD POINTER TO DSNAME           00061300
         CLI   0(R5),C'*'              SEE IF DSNAME IS ASTERISK    WFB 00061400
         BE    ALLOCDDN                YES, GO PROCESS DDNAME       WFB 00061500
         LH    R4,4(R6)                LOAD LENGTH OF DSNAME            00061600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00061700
**************************** START OF GTEL MOD ************************ 00061800
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00061900
*   DETERMINE THE FULL DATASET NAME GIVEN                               00062000
         STH   R4,DFPBDSL              STORE LENGTH OF DSN              00062100
         TM    6(R6),X'40'             IN QUOTES                        00062200
         BO    GTENOQ                  YES, SKIP                        00062300
         BCTR  R4,0                    DECREMENT COUNT                  00062400
         MVC   DFPBNAME,BLANKS         MOVE IN BLANKS                   00062500
         EX    R4,DFPBMVE              MOVE IN DSN GIVEN                00062600
         LA    R4,1(R4)                BUMP COUNT                ARAMCO 00062700
         LA    R1,DFPLSECT             GET ADDRESS OF ECT               00062800
         MVC   DFPBQUA,BLANKS          BLANK QUALIFIER                  00062900
         CALLTSSR  EP=IKJEHDEF         GO TO DEFAULT ROUTINE            00063000
GTEDEF   LTR    R15,R15                TEST RETURN CODE                 00063100
         BNZ    GTENOQ                 NON ZERO SKIP                    00063200
GTEOK    LA     R5,DFPBNAME            RESTORE REGS                     00063300
         LH     R4,DFPBDSL             GET NEW LENGTH                   00063400
GTENOQ   DS    0H                                                       00063500
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00063600
**************************** END OF GTEL MOD ************************** 00063700
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00063800
         STCM  R4,3,DSNLEN             STORE LENGTH OF DSNAME           00063900
         BCTR  R4,0                    DECREMENT LENGTH FOR EXECUTE OF  00064000
*                                      MOVE                             00064100
         LA    R8,DAP08                LOAD ADDRESS OF DAPB FOR 08      00064200
         USING DAPB08,R8               ESTABLISH ADDRESSABILITY TO DAPB 00064300
         MVC   DAPB08(DAPB08L),DAPB08C MOVE CONSTANTS INTO DAPB         00064400
         LA    R1,DSNLEN               LOAD POINTER TO DSN BUFFER       00064500
         ST    R1,DA08PDSN             STORE POINTER TO DSN BUFFER IN   00064600
*                                      DAPB                             00064700
         MVI   DSNBUF,BLANK            BLANK OUT THE DSNAME BUFFER      00064800
         MVC   DSNBUF+1(43),DSNBUF     FINISH BLANKING OUT THE BUFFER   00064900
         EX    R4,MOVEDSN              MOVE IN THE DSNAME               00065000
         TM    14(R6),HIGH             SEE IF MEMBER NAME IS PRESENT    00065100
         BNO   CHKPASS                 NO.....GO CHECK IF THERE IS A    00065200
*                                      PASSWORD                         00065300
         L     R5,8(R6)                LOAD POINTER TO THE MEMBER NAME  00065400
         LH    R4,12(R6)               LOAD LENGTH OF MEMBER NAME       00065500
         BCTR  R4,0                    DECREMENT LENGTH FOR EXECUTE OF  00065600
*                                      MOVE                             00065700
         EX    R4,MOVEMEM              MOVE IN THE MEMBER NAME          00065800
CHKPASS  DS    0H                                                       00065900
         MVC   MEMNAME,DA08MNM         MOVE MEMBER NAME INTO HEADER 2   00066000
         TM    22(R6),HIGH             SEE IF PASSWORD IS PRESENT       00066100
         BNO   CHKVOL                  NO.....GO SEE IF VOLUME PRESENT  00066200
         L     R5,16(R6)               LOAD POINTER TO THE PASSWORD     00066300
         LH    R4,20(R6)               LOAD LENGTH OF PASSWORD          00066400
         BCTR  R4,0                    DECREMENT LENGTH FOR EXECUTE OF  00066500
*                                      MOVE                             00066600
         EX    R4,MOVEPASS             MOVE IN THE PASSWORD             00066700
CHKVOL   DS    0H                                                       00066800
         TM    VOLBIT,HIGH             SEE IF VOLUME IS PRESENT         00066900
         BNO   ALLOCDD                 NO.....GO ALLOCATE DATA SET      00067000
         MVC   DA08SER,VOLUME          MOVE IN THE VOLUME SERIAL        00067100
         TM    VOLBIT,MID1             SEE IF UNIT IS PRESENT       WFB 00067200
*                                 ===> O N L Y  IF VOLUME SPECIFIED WFB 00067300
         BNO   ALLOCDD                 NO.....GO ALLOCATE DATA SET  WFB 00067400
         MVC   DA08UNIT,UNIT           MOVE IN THE UNIT TYPE        WFB 00067500
ALLOCDD  DS    0H                                                       00067600
         SLR   R4,R4                   ZERO REGISTER 4                  00067700
         ST    R4,ECB                  STORE REGISTER 4 AS ECB          00067800
         LA    R1,DAPLSECT             LOAD ADDRESS OF DAPL             00067900
         USING DAPL,R1                 ESTABLISH ADDRESSABILITY TO DAPL 00068000
         ST    R8,DAPLDAPB             STORE ADDRESS OF DAPB IN DAPL    00068100
         DROP  R1                      DROP ADDRESSABILITY TO DAPL      00068200
         CALLTSSR EP=IKJDAIR           CALL DAIR TO ALLOCATE DATASET    00068300
         LTR   R15,R15                 SEE IF RETURN CODE IS ZERO       00068400
         BZ    OUTPUT                  YES....GO PRINT DATASET          00068500
         MVI   DFID+1,DFDAIR           SET DAIRFAIL ID TO INDICATE DAIR 00068600
         BAL   R2,DAIRFAIL             GO TO DAIRFAIL ROUTINE TO HAVE   00068700
*                                      ERROR MESSAGE PUT OUT            00068800
NOTPMESS DS    0H                                                       00068900
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00069000
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00069100
         PUTLINE OUTPUT=(DSNNOTP,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT  00069200
*                                      DATASET NOT PRINTED MESSAGE      00069300
         DROP  R15                                                  WFB 00069400
         B     EXITMSG                 GO PUT OUT DATASET AND MEMBER    00069500
*                                      NAMES                            00069600
*                                                                       00069700
*********************************************************************** 00069800
*                                                                     * 00069900
*        DETERMINE DATASET TYPE AND CALL PRINT ROUTINE                * 00070000
*                                                                     * 00070100
*********************************************************************** 00070200
*                                                                       00070300
OUTPUT   DS    0H                                                       00070400
         TM    DA08DSO,DSOPS           X'40' PHYSICAL SEQUENTIAL        00070500
         BO    PRINTIT                 YES....GO PRINT DATASET          00070600
         CLC   DA08MNM,BLANKS          SEE IF MEMBER NAME IS BLANK      00070700
         BNE   PRINTIT                 NO.....GO TREAT AS SEQUENTIAL    00070800
         TM    DA08DSO,DSOPO           X'02' PARTITIONED                00070900
         BO    SCROLLIT                YES....GO SCROLL DIRECTORY       00071000
         DROP  R8                      DROP ADDRESSABILITY TO DAPB      00071100
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00071200
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00071300
         PUTLINE OUTPUT=(NOTPSPO,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT  00071400
*                                      NOT PARTITIONED OR SEQUENTIAL    00071500
*                                      MESSAGE                          00071600
         DROP  R15                                                  WFB 00071700
         B     NOTPMESS                GO PUT NOT PRINTED MESSAGE       00071800
*                                                                   WFB 00071900
ALLOCDDN DS    0H                                                   WFB 00072000
         L     R1,24(,R6)              LOAD POINTER TO NEXT DSN     WFB 00072100
         C     R1,ENDCHAIN             IS DSN=* LAST OR ONLY NAME ? WFB 00072200
         BE    CHKINFO                 YES, GO GET DSN, DSORG INFO  WFB 00072300
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00072400
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00072500
         PUTLINE OUTPUT=(NOTLAST,SINGLE,DATA),MF=(E,IOPLSECT)  PUT  WFB 00072600
*                                      DSN=* IS NOT LAST OR ONLY    WFB 00072700
*                                      MESSAGE                      WFB 00072800
         DROP  R15                                                  WFB 00072900
         B     NOTPMESS                GO PUT NOT PRINTED MESSAGE   WFB 00073000
CHKINFO  DS    0H                                                   WFB 00073100
         LA    R8,REQBLK               GET POINTER TO REQUEST BLOCK WFB 00073200
         ST    R8,RBPTR                INITIALIZE REQUEST BLOCK PTR WFB 00073300
         MVI   RBPTR,S99RBPND          INDICATE END OF PARM LIST    WFB 00073400
         USING S99RB,R8                ESTABLISH ADDRESSABILITY TO  WFB 00073500
*                                      REQUEST BLOCK                WFB 00073600
         MVC   S99RBLN(RBLEN),REQBLKC  INITALIZE RB                 WFB 00073700
         MVI   S99VERB,S99VRBIN        SET VERB TO INFO RETRIEVAL   WFB 00073800
         LA    R1,TEXTPTRS             GET POINTER TO TEXT POINTERS WFB 00073900
         ST    R1,S99TXTPP             STORE POINTER IN RB          WFB 00074000
         DROP  R8                      DROP ADDRESSABILITY TO RB    WFB 00074100
         USING S99TUPL,R1              ESTABLISH ADDRESSABILITY TO  WFB 00074200
*                                      TEXT UNIT POINTER LIST       WFB 00074300
         LA    R2,TEXTL                ADDRESS PREALLOC DDNAME TEXT WFB 00074400
         ST    R2,S99TUPTR             STORE POINTER IN TUPL        WFB 00074500
         USING S99TUNIT,R2             ESTABLISH ADDRESSABILITY TO  WFB 00074600
*                                      TEXT UNIT                    WFB 00074700
         MVC   S99TUKEY(TEXTLLEN),TEXTLC  INITIALIZE TEXT UNIT L    WFB 00074800
         L     R9,PARSBACK             LOAD POINTER TO PARS ANSWER  WFB 00074900
         USING IKJPARMD,R9             ESTABLISH ADDRESSABILITY     WFB 00075000
         L     R5,SDDNAME              GET ADDRESS OF DDNAME        WFB 00075100
         LH    R4,SDDNAME+4            GET LENGTH OF DDNAME         WFB 00075200
         DROP  R9                                                   WFB 00075300
         BCTR  R4,0                    DECREMENT FOR EXECUTE        WFB 00075400
         EX    R4,MOVEDDN              MOVE DDNAME INTO TEXT UNIT   WFB 00075500
         MVC   PREALDDN,S99TUPAR       SAVE PREALLOC DDN FOR LATER  WFB 00075600
         LA    R1,4(,R1)               POINT TO NEXT TEXT UNIT PTR  WFB 00075700
         LA    R2,TEXTM                ADDRESS RETURN DSNAME TEXT U WFB 00075800
         ST    R2,S99TUPTR             STORE POINTER IN TUPL        WFB 00075900
         MVC   S99TUKEY(TEXTMLEN),TEXTMC  INITIALIZE TEXT UNIT M    WFB 00076000
         LA    R1,4(,R1)               POINT TO NEXT TEXT UNIT PTR  WFB 00076100
         LA    R2,TEXTN                ADDRESS RETURN MEMBER TEXT U WFB 00076200
         ST    R2,S99TUPTR             STORE POINTER IN TUPL        WFB 00076300
         MVC   S99TUKEY(TEXTNLEN),TEXTNC  INITIALIZE TEXT UNIT N    WFB 00076400
         LA    R1,4(,R1)               POINT TO NEXT TEXT UNIT PTR  WFB 00076500
         LA    R2,TEXTO                ADDRESS RETURN DSORG TEXT U  WFB 00076600
         ST    R2,S99TUPTR             STORE POINTER IN TUPL        WFB 00076700
         MVC   S99TUKEY(TEXTOLEN),TEXTOC  INITIALIZE TEXT UNIT O    WFB 00076800
         MVI   S99TUPTR,S99TUPLN       INDICATE END TEXT UNIT PTRS  WFB 00076900
         DROP  R1,R2                   DROP ADDRESSABILITY          WFB 00077000
         LA    R1,RBPTR                ADDRESS SVC99 REQUEST BLOCK  WFB 00077100
         DYNALLOC                      ISSUE DYNAMIC ALLOCATION SVC WFB 00077200
         LTR   R15,R15                 SEE IF RETURN CODE IS ZERO   WFB 00077300
         BZ    CHKDDORG                YES....GO CHECK DSORG TYPE   WFB 00077400
         LA    R1,REQBLK               ADDRESS SVC99 REQUEST BLOCK  WFB 00077500
         MVI   DFID+1,DFSVC99          SET DAIRFAIL ID = DYNALLOC   WFB 00077600
         BAL   R2,DAIRFAIL             GO TO DAIRFAIL ROUTINE TO    WFB 00077700
         B     NOTPMESS                GO PUT NOT PRINTED MESSAGE   WFB 00077800
CHKDDORG DS    0H                                                   WFB 00077900
         LA    R1,TEXTM                ADDRESS RETURNED DSNAME TEXT WFB 00078000
         USING S99TUNIT,R1             ESTABLISH ADDRESSABILITY     WFB 00078100
         MVC   DFPBDSL,S99TULNG        SAVE DSN LEN WHERE EXPECTED  WFB 00078200
         MVC   DSNAME,S99TUPAR         MOVE RETURN DSN INTO HEADER  WFB 00078300
         LA    R1,TEXTN                ADDRESS RETURNED MEMBER TEXT WFB 00078400
         MVC   MEMNAME,S99TUPAR        MOVE RETURN MEM INTO HEADER  WFB 00078500
         MVC   VOLHEAD,DDNCONST        MOVE '   DDNAME: ' TO HEADER WFB 00078600
         MVC   VOLNAME,PREALDDN        MOVE DDNAME TO HEADING       WFB 00078700
         LA    R1,TEXTO                ADDRESS RETURNED DSORG TEXT  WFB 00078800
         TM    S99TUPAR,DSOPS          X'40' PHYSICAL SEQUENTIAL    WFB 00078900
         BO    PRINTIT                 YES....GO PRINT DATASET      WFB 00079000
         CLI   MEMNAME,BLANK           SEE IF MEMBER NAME IS BLANK  WFB 00079100
         BNE   PRINTIT                 NO.....GO TREAT AS SEQUENTIALWFB 00079200
         TM    S99TUPAR,DSOPO          X'02' PARTITIONED            WFB 00079300
         BO    SCROLLIT                YES....GO SCROLL DIRECTORY   WFB 00079400
         DROP  R1                      DROP ADDRESSABILITY TO S99TU WFB 00079500
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00079600
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00079700
         PUTLINE OUTPUT=(NOTPSPO,SINGLE,DATA),MF=(E,IOPLSECT)  PUT  WFB 00079800
*                                      NOT PARTITIONED OR SEQUENTIALWFB 00079900
*                                      MESSAGE                      WFB 00080000
         DROP  R15                                                  WFB 00080100
         B     NOTPMESS                GO PUT NOT PRINTED MESSAGE   WFB 00080200
*                                                                       00080300
*********************************************************************** 00080400
*                                                                     * 00080500
*        READS RECORDS USING GET MOVE                                 * 00080600
*           AND ATTRIBUTES OF GIVEN DATASET                           * 00080700
*        WRITES THESE SAME RECORDS USING PUT MOVE                     * 00080800
*           AND THE INPUT DATASET ATTRIBUTES                          * 00080900
*                                                                     * 00081000
*********************************************************************** 00081100
*                                                                       00081200
PRINTIT  DS    0H                                                       00081300
         LA    R8,INPUT                LOAD POINTER TO INPUT DCB        00081400
         USING IHADCB,R8               ESTABLISH ADDRESSABILITY TO DCB  00081500
         MVC   INPUT(INPUTL),INPUTC    MOVE INPUT DCB CONSTANT INTO     00081600
*                                      INPUT DCB IN WORKAREA            00081700
         L     R1,0(,R6)               GET ADDRESS OF DSNAME        WFB 00081800
         CLI   0(R1),C'*'              SEE IF DSNAME IS ASTERISK    WFB 00081900
         BNE   OPENINP                 NO, GO OPEN INPUT            WFB 00082000
         MVC   DCBDDNAM,PREALDDN       YES, USE PREALLOCATED DDN(.) WFB 00082100
OPENINP  DS    0H                                                   WFB 00082200
         MVC   OPENLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00082300
*                                      INTO OPEN LIST IN WORKAREA       00082400
         OPEN  ((R8),INPUT),MF=(E,OPENLST)  OPEN INPUT DCB              00082500
PRINTS   DS    0H                      BRANCH ADDRESS FOR PRINTING      00082600
*                                      MEMBERS                          00082700
         TM    DCBOFLGS,DCBOFOPN       SEE IF DCB OPENED SUCCESSFULLY   00082800
         BNO   NOTPMESS                NO.....GO PUT OUT NOT PRINTED    00082900
*                                      MESSAGE                          00083000
CHKCNTRL DS    0H                                                       00083100
         MVC   HEADER,HEADERC          MOVE HEADER INTO DATA AREA       00083200
         TM    DCBRECFM,DCBRECCM       SEE IF CONTROL IS MACHINE        00083300
         BNO   USEA                    NO.....GO TO USE ASA CONTROL     00083400
         LA    R5,OUTPUTM              LOAD ADDRESS OF OUTPUT DCB FOR   00083500
*                                      MACHINE CODE                     00083600
         LA    R4,EJECTM               LOAD ADDRESS OF EJECT DATA       00083700
         MVI   HDRCNTL,SKIPM           MOVE INTO HEADER MACHINE CODE    00083800
*                                      FOR SPACE                        00083900
         TM    48(R5),DCBOFOPN         SEE IF DCB IS ALREADY OPEN       00084000
         BO    PUTDSN                  YES....GO PUT OUT HEADERS        00084100
         LA    R3,PRINTM               LOAD POINTER TO PRINTM           00084200
         LA    R14,PUTDSN              LOAD ADDRESS FROM RETURN FROM    00084300
*                                      SYSOUT ALLOCATION                00084400
         B     ALLOCOUT                GO TO ALLOCATE SYSOUT            00084500
USEA     DS    0H                                                       00084600
         LA    R5,OUTPUTA              LOAD ADDRESS OF OUTPUT DCB FOR   00084700
*                                      ASA CODE                         00084800
         LA    R4,EJECTA               LOAD ADDRESS OF EJECT DATA       00084900
         TM    48(R5),DCBOFOPN         SEE IF DCB IS ALREADY OPEN       00085000
         BO    PUTDSN                  YES....GO PUT OUT HEADERS        00085100
         LA    R3,PRINTA               LOAD POINTER TO PRINTA           00085200
         BAL   R14,ALLOCOUT            LOAD ADDRESS FOR RETURN AND GO   00085300
*                                      DO SYSOUT ALLOCATION             00085400
PUTDSN   DS    0H                                                       00085500
         TM    VOLBIT,UDKDONE          UDKS WRITTEN ALREADY ?       WFB 00085600
         BO    NOUDK                   YES, SKIP                    WFB 00085700
         L     R9,PARSBACK             LOAD POINTER TO PARS ANSWER  WFB 00085800
         USING IKJPARMD,R9             ESTABLISH ADDRESABILITY      WFB 00085900
         CLC   PUDKFONT(2),HALF1       IS UDK FONT SPECIFIED ?      WFB 00086000
         BNE   NOUDK                   NO, SKIP                     WFB 00086100
         PUT   (R5),UDKRESET           PUT OUT UDK RESET TEXT       WFB 00086200
         PUT   (R5),UDKSET             PUT OUT UDK SET TEXT         WFB 00086300
         L     R15,ALNDSECT            POINT TO RECORD WORK AREA    WFB 00086400
         USING LINDSECT,R15            ESTABLISH ADDRESSABILITY     WFB 00086500
         MVC   RECORD(8),UDKFHEAD      MOVE UDK FONT NAME HEADER    WFB 00086600
         L     R14,SUDKFONT            POINT TO UDK FONT NAME       WFB 00086700
         LH    R1,SUDKFONT+4           GET LENGTH OF UDK FONT NAME  WFB 00086800
         BCTR  R1,0                    DECREMENT FOR EXECUTE        WFB 00086900
         EX    R1,MOVEUDK              MOVE UDK FONT NAME TO RECORD WFB 00087000
         LA    R1,9(,R1)               ADD HEADER LEN TO ACTUAL LEN WFB 00087100
         STH   R1,RECLEN               SAVE IN OUTPUT RECORD        WFB 00087200
         PUT   (R5),(R15)              PUT OUT UDK FONT NAME        WFB 00087300
         DROP  R9,R15                                               WFB 00087400
         PUT   (R5),UDKFSEL            PUT OUT UDK FONT SELECT TEXT WFB 00087500
         OI    VOLBIT,UDKDONE          INDICATE UDKS WRITTEN        WFB 00087600
NOUDK    DS    0H                                                   WFB 00087700
         TM    VOLBIT,MID2             TEST FOR NOHEAD             GTEL 00087800
         BO    NOHEAD                  YES                         GTEL 00087900
         PUT   (R5),(R4)               PUT OUT PAGE EJECT           WFB 00088000
         MVC   HDRTIME(HDRTDLEN),BLANKS  BLANK OUT TIME DATE AREAS  WFB 00088100
         CALL  IKJEFLPA,(HDRTIME,HDRDATE),VL,MF=(E,CALLMFL)         WFB 00088200
         MVC   HDRTIME(4),BLANKS       BLANK OUT BUFFER PREFIX      WFB 00088300
         MVC   HDRDATE(4),BLANKS       BLANK OUT BUFFER PREFIX      WFB 00088400
         PUT   (R5),HEADER             PUT OUT PAGE 1 HEADER            00088500
         MVC   HEADER2,LDSNAME         MOVE LENGTH AND 'DSNAME=' INTO   00088600
*                                      INTO SECOND HEADER               00088700
         MVC   HEADER2+4(1),HDRCNTL    MOVE IN CONTROL BYTE             00088800
         CLI   MEMNAME,BLANK           SEE IF MEMBER NAME IS BLANK      00088900
         BE    NOMEM                   YES....NO NEED TO PUT IN PARENS  00089000
         MVI   OPENPRN,C'('            MOVE OPEN PAREN INTO DSNAME      00089100
         MVI   CLOSEPRN,C')'           MOVE CLOSE PAREN INTO DSNAME     00089200
         B     PUTHDR2                 GO PUT OUT HEADER 2              00089300
NOMEM    DS    0H                                                       00089400
         MVI   OPENPRN,BLANK           MOVE BLANK INSTEAD OF OPEN AND   00089500
         MVI   CLOSEPRN,BLANK          CLOSE PARENS                     00089600
PUTHDR2  DS    0H                                                       00089700
         PUT   (R5),HEADER2            PUT OUT PAGE 1 HEADER 2          00089800
         MVC   HEADER2(4),SPACE        CHANGE HEADER 2 FOR PUT OF BLANK 00089900
*                                      LINE                             00090000
         PUT   (R5),HEADER2            PUT OUT BLANK LINE               00090100
NOHEAD   STM   R9,R10,SAVMR9           SAVE REGS 9 AND 10               00090200
         STM   R6,R7,SAVMR6            SAVE REGS 6 AND 7                00090300
         STM   R2,R3,SAVMR2            SAVE REGS 2 AND 3                00090400
         L     R9,ALNDSECT             SET UP RECORD ADDRESS.           00090500
         USING LINDSECT,R9             *                                00090600
         SLR   R10,R10                 ZERO OUT R10                     00090700
         LH    R7,PAGELEN              MOVE IN PAGELEN                  00090800
         TM    VOLBIT,MID2             NOHEAD SPECIFIED ?           WFB 00090900
         BO    NOSUB4                  YES, SKIP SUBTRACTION        WFB 00091000
         SH    R7,HALF4                SUBTRACT FOR HEADER       ARAMCO 00091100
NOSUB4   DS    0H                                                   WFB 00091200
         MVC   RECCC,HDRCNTL           MOVE IN SPACE AS CONTROL         00091300
*                                      CHARACTER                        00091400
         TM    DCBRECFM,DCBRECU        SEE IF RECFM U                   00091500
         BO    COPYU                   YES....GO HANDLE RECFM U         00091600
         TM    DCBRECFM,DCBRECV        SEE IF RECFM V                   00091700
         BO    COPYV                   YES....GO HANDLE RECFM V         00091800
COPYF    DS    0H                                                       00091900
         TM    DCBRECFM,DCBRECCC       CONTROL CHARACTER?               00092000
         BNZ   COPYFCC                 YES...                           00092100
         TM    CCBIT,FORCEASA          USER SAYS CC IN DATA ?       WFB 00092200
         BO    COPYFCC                 YES, PROCESS AS SO           WFB 00092300
COPYFNC  OI    CCBIT,LOW               TURN ON NOCC BIT                 00092400
         LH    R4,DCBLRECL             GET LRECL                        00092500
         A     R4,FULL5                ADD LENGTH FOR VB HEADER         00092600
         STH   R4,RECLEN               PUT INTO RECORD HEADER           00092700
         GET   INPUT,RECDATA           GET INPUT                        00092800
         BAL   R10,PUTLL               PUT OUT LINE                     00092900
         L     R9,ALNDSECT             RELOAD DSECT POINTER             00093000
         B     COPYFNC                 GET NEXT RECORD                  00093100
COPYFCC  LH    R4,DCBLRECL             GET LRECL                        00093200
         A     R4,FULL4                ADD LENGTH FOR VB HEADER         00093300
         STH   R4,RECLEN               PUT INTO RECORD HEADER           00093400
         GET   INPUT,RECCC             GET INPUT                        00093500
         BAL   R10,PUTLL               PUT INTO RECORD HEADER           00093600
         L     R9,ALNDSECT             RELOAD DSECT POINTER             00093700
         B     COPYFCC                 GET NEXT RECORD                  00093800
COPYV    DS    0H                                                       00093900
         TM    DCBRECFM,DCBRECCC       CONTROL CHARACTER?               00094000
         BNZ   COPYVCC                 IF YES...                        00094100
         TM    CCBIT,FORCEASA          USER SAYS CC IN DATA ?       WFB 00094200
         BO    COPYVCC                 YES, PROCESS AS SO           WFB 00094300
COPYVNC  GET   INPUT,RECLEN+1          GET INPUT                        00094400
         OI    CCBIT,LOW               TURN ON NOCC BIT                 00094500
         SLR   R15,R15                 ZERO R15                         00094600
         ICM   R15,7,RECLEN+1          GET LENGTH                       00094700
         A     R15,FULL256             ADD ONE FOR CC                   00094800
         STCM  R15,7,RECLEN            REPLACE LENGTH OVER 1            00094900
         MVC   RECCC,HDRCNTL           ADD HDRCNTL                      00095000
         BAL   R10,PUTLL               PUT OUT RECORD                   00095100
         L     R9,ALNDSECT             RESTORE DSECT ADDRESS            00095200
         B     COPYVNC                 GET NEXT RECORD                  00095300
COPYVCC  GET   INPUT,RECLEN            GET INPUT                        00095400
         BAL   R10,PUTLL               PUT OUT RECORD                   00095500
         L     R9,ALNDSECT             RESTORE DSECT ADDRESS            00095600
         B     COPYVCC                 GET NEXT RECORD                  00095700
COPYU    DS    0H                      PROCESS RECFM=U                  00095800
         TM    DCBRECFM,DCBRECCC       CONTROL CHARACTER?               00095900
         BNZ   COPYUCC                 YES...                           00096000
         TM    CCBIT,FORCEASA          USER SAYS CC IN DATA ?       WFB 00096100
         BO    COPYUCC                 YES, PROCESS AS SO           WFB 00096200
COPYUNC  GET   INPUT,RECDATA           GET RECORD                       00096300
         OI    CCBIT,LOW               TURN ON NOCC BIT                 00096400
         LH    R4,DCBLRECL             GET LRECL                        00096500
         A     R4,FULL5                ADD VB HEADER LENGTH             00096600
         STH   R4,RECLEN               PUT INTO RECORD HEADER           00096700
         BAL   R10,PUTLL               PUT OUT LINE                     00096800
         L     R9,ALNDSECT             RELOAD DSECT POINTER             00096900
         B     COPYUNC                 GET NEXT RECORD                  00097000
COPYUCC  GET   INPUT,RECCC             GET INPUT                        00097100
         LH    R4,DCBLRECL             GET LRECL                        00097200
         A     R4,FULL4                ADD VB HEADER LENGTH             00097300
         STH   R4,RECLEN               STORE INTO RECORD HEADER         00097400
         BAL   R10,PUTLL               PUT INTO RECORD HEADER           00097500
         L     R9,ALNDSECT             RELOAD DSECT POINTER             00097600
         B     COPYUCC                 GET NEXT RECORD                  00097700
PUTLL    DS    0H                                                       00097800
         TM    CCBIT,X'99'             NOCC, DS, SS, OR PAGELEN ON?     00097900
         BZ    NOSKIP                  NO, IGNORE LINE-COUNTING         00098000
         LTR   R7,R7                   ANY LINES LEFT ON PAGE?          00098100
         BNZ   LINECT                  YES, DON'T PUT IN PAGE SKIP CC   00098200
         MVI   4(R9),HEXF1             MOVE IN PAGE SKIP CC             00098300
         LH    R7,PAGELEN              RESET LINE COUNT                 00098400
         B     NOSKIP                  CONTINUE WITH PUT                00098500
LINECT   TM    CCBIT,MID2              WAS DOUBLE SPACE SPECIFIED?      00098600
         BO    LINEDS                  YES, CHECK LINES LEFT     ARAMCO 00098700
         MVI   4(R9),BLANK             PUT IN SINGLE SPACE CONTROL CHAR 00098800
         B     NOSKIP                  YES, DON'T SKIP TO NEXT PAGE     00098900
LINEDS   BCTR  R7,0                    DECREMENT ONE MORE FOR DS        00099000
         MVI   4(R9),HEXF0             PUT IN DOUBLE SPACE CONTROL CHAR 00099100
         SLR   R2,R2                   EMPTY R2 FOR DIVIDE              00099200
         SLR   R3,R3                   EMPTY R3 FOR DIVIDE              00099300
         SLR   R15,R15                 EMPTY R15 FOR DIVIDE             00099400
         LH    R15,LINELEN             LOAD LINELEN INTO R15            00099500
         LH    R3,RECLEN               PUT REC LENGTH IN R2             00099600
         SH    R3,HALF5                SUBTRACT VB HEADER LENGTH        00099700
         DR    R2,R15                  DIVIDE BY LINELEN                00099800
         CR    R3,R7                   GREATER THAN LINES LEFT ON PAGE? 00099900
         BNH   NOSKIP                  IF NOT....DON'T START NEW PAGE   00100000
         MVI   4(R9),HEXF1             MOVE IN PAGE SKIP CC             00100100
         LH    R7,PAGELEN              RESET LINE COUNT                 00100200
NOSKIP   LH    R4,RECLEN               PUT REC LENGTH IN R4             00100300
         TM    VOLBIT,LOW              SEE IF FOLD IS REQUESTED         00100400
         BO    FOLDLOOP                YES....GO FOLD OUTPUT            00100500
PUTLOOP  CH    R4,VBLEN                COMPARE WITH LL                  00100600
         BNH   PUTLAST                 WRITE LAST RECORD                00100700
         MVC   0(2,R9),VBLEN           INSERT LENGTH FOR PUT            00100800
         PUT   (R5),(R9)               PUT OUT OUTPUT LINE              00100900
         SH    R4,LINELEN              DECREMENT FOR COMPARE            00101000
         AH    R9,LINELEN              INCREMENT RECORD LOCATN          00101100
         MVI   4(R9),BLANK             MOVE IN NEXT LINE CC             00101200
         TM    CCBIT,X'99'             NOCC, PAGELEN, DS, OR SS SPEC?   00101300
         BZ    PUTLOOP                 NO, DON'T COUNT LINES            00101400
         BCT   R7,PUTLOOP              END OF PAGE?                     00101500
         MVI   4(R9),HEXF1             YES, START NEW PAGE              00101600
         LH    R7,PAGELEN              RELOAD PAGELEN                   00101700
         B     PUTLOOP                 WRITE NEXT LINE                  00101800
FOLDLOOP CH    R4,VBLEN                COMPARE WITH LL                  00101900
         BNH   FOLDLAST                WRITE LAST RECORD                00102000
         LH    R15,LINELEN             LOAD LINE LENGTH                 00102100
         SH    R15,HALF1               DECREMENT FOR EXECUTE            00102200
         EX    R15,FOLDLINE            EXECUTE FOLD OF LINE             00102300
         MVC   0(2,R9),VBLEN           INSERT LENGTH FOR PUT            00102400
         PUT   (R5),(R9)               PUT OUT OUTPUT LINE              00102500
         SH    R4,LINELEN              DECREMENT FOR COMPARE            00102600
         AH    R9,LINELEN              INCREMENT RECORD LOCATION        00102700
         MVI   4(R9),BLANK             MOVE IN NEXT LINE CC             00102800
         TM    CCBIT,X'99'             NOCC, PAGELEN, DS, OR SS SPEC?   00102900
         BZ    FOLDLOOP                NO, DON'T COUNT LINES            00103000
         BCT   R7,FOLDLOOP             END OF PAGE?                     00103100
         MVI   4(R9),HEXF1             YES, START NEW PAGE              00103200
         LH    R7,PAGELEN              RELOAD PAGELEN                   00103300
         B     FOLDLOOP                WRITE NEXT LINE                  00103400
FOLDLAST LR    R15,R4                  LOAD REMAINING LINE LENGTH       00103500
         SH    R15,HALF6               DECREMENT FOR EXECUTE            00103600
         EX    R15,FOLDLINE            EXECUTE FOLD OF LINE             00103700
PUTLAST  STH   R4,0(R9)                INSERT LENGTH FOR PUT            00103800
         PUT   (R5),(R9)               PUT OUT OUTPUT LINE              00103900
         BCTR  R7,0                    DECREMENT PAGELEN                00104000
         BR    R10                     GO GET NEXT RECORD               00104100
EXITI    DS    0H                                                       00104200
         DROP  R9                                                       00104300
         LM    R9,R10,SAVMR9           RESTORE R9 AND R10               00104400
         LM    R6,R7,SAVMR6            RESTORE R6 AND R7                00104500
         LM    R2,R3,SAVMR2            RESTORE R2 AND R3                00104600
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00104700
**************************** END OF GTEL MOD ************************** 00104800
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00104900
EXIT     DS    0H                                                       00105000
         TM    DCBOFLGS,DCBOFOPN       SEE IF INPUT DCB IS OPEN         00105100
         BNO   EXITMSG                 NO....GO PUT OUT DATASET AND     00105200
*                                      MEMBER NAMES                     00105300
         MVC   CLOSLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00105400
*                                      INTO CLOSE LIST IN WORKAREA      00105500
         CLOSE ((R8),),MF=(E,CLOSLST)  CLOSE INPUT DCB                  00105600
EXITMSG  DS    0H                                                       00105700
         L     R1,0(,R6)               GET ADDRESS OF DSNAME        WFB 00105800
         CLI   0(R1),C'*'              SEE IF DSNAME IS ASTERISK    WFB 00105900
         BE    EXNOFREE                YES, DO NOT FREE DDN(...)    WFB 00106000
         LA    R1,PRINTI               FREE INPUT DATASET          GTEL 00106100
         BAL   R2,FREEDD               FREE INPUT DATASET          GTEL 00106200
EXNOFREE DS    0H                                                   WFB 00106300
         TM    VOLBIT,NOMSG            IS NOMSG SPECIFIED ?         WFB 00106400
         BO    CONTINUE                YES, CONTINUE WITH NEXT DSN  WFB 00106500
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00106600
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00106700
         PUTLINE OUTPUT=(DSNMSG,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT   00106800
*                                      DATA SET NAME MESSAGE            00106900
         DROP  R15                                                  WFB 00107000
         LH    R4,DFPBDSL              LOAD LENGTH OF DSNAME       GTEL 00107100
         A     R4,FULL4                INCREMENT LENGTH FOR PUTLINE     00107200
         SLL   R4,16                   SHIFT LENGTH TO HIGH ORDER BYTES 00107300
         STCM  R4,15,DSNLENP           STORE LENGTH OF PUTLINE          00107400
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00107500
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00107600
         PUTLINE OUTPUT=(DSNLENP,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT  00107700
*                                      DATA SET NAME MESSAGE            00107800
         DROP  R15                                                  WFB 00107900
         CLI   MEMNAME,BLANK           MEMBER NAME BLANK ?          WFB 00108000
         BE    CONTINUE                YES, SKIP MEMBER MESSAGE     WFB 00108100
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00108200
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00108300
         PUTLINE OUTPUT=(MEMMSG,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT   00108400
*                                      DATA SET NAME MESSAGE            00108500
         DROP  R15                                                  WFB 00108600
         MVC   MEMNAMEL(2),HALF12      FORCE MEMNAME LENGTH 8 (+4)  WFB 00108700
         MVC   MEMNAMEL+2(2),HALF0     (REQUIRED ZERO FOR PUTLINE)  WFB 00108800
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00108900
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00109000
         PUTLINE OUTPUT=(MEMNAMEL,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT 00109100
*                                      MEMBER NAME                      00109200
         DROP  R15                                                  WFB 00109300
         B     CONTINUE                GO CONTINUE WITH NEXT DATASET    00109400
         DROP  R8                      DROP ADDRESSABILITY TO INPUT DCB 00109500
ERRI     DS    0H                                                       00109600
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00109700
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00109800
         PUTLINE OUTPUT=(SYNADI,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT   00109900
*                                      DATASET NOT PRINTED DUE TO SYNAD 00110000
*                                      ERROR ON INPUT DATASET MESSAGE   00110100
         DROP  R15                                                  WFB 00110200
         B     EXIT                    GO SEE IF INPUT DCB IS OPEN      00110300
ERRO     DS    0H                                                       00110400
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00110500
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00110600
         PUTLINE OUTPUT=(SYNADO,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT   00110700
*                                      DATASET NOT PRINTED DUE TO       00110800
*                                      SYNAD ERROR MESSAGE          WFB 00110900
         DROP  R15                                                  WFB 00111000
         B     CLOSDCBS                GO CLOSE OPEN DCBS AND RETURN    00111100
*                                                                     * 00111200
*********************************************************************** 00111300
*                                                                     * 00111400
*        READ THE DIRECTORY OF A PDS                                  * 00111500
*           THEN EITHER LIST MEMBER NAMES,                            * 00111600
*           PRINT MEMBERS,                                            * 00111700
*           OR LIST MEMBER NAMES AND PRINT MEMBERS                    * 00111800
*                                                                     * 00111900
*********************************************************************** 00112000
*                                                                       00112100
SCROLLIT DS    0H                                                       00112200
         ST    R6,SAVER6               SAVE REGISTER 6                  00112300
         L     R9,PARSBACK             LOAD ADDRESS PARS ANSWER         00112400
         USING IKJPARMD,R9             ESTABLISH ADDRESSABILITY TO PDL  00112500
         CLC   PLIST,HALF2             SEE IF NOLIST SPECIFIED          00112600
         BL    CONTSCR                 LOW....CONTINUE WITH SCROLL      00112700
         CLC   PPRINT,HALF2            SEE IF NOPRINT SPECIFIED         00112800
         BE    CONTINUE                YES....SKIP SCROLL               00112900
         DROP  R9                      DROP ADDRESSABILITY TO PDL       00113000
CONTSCR  DS    0H                                                       00113100
         LA    R8,DIRECT               LOAD POINTER TO DIRECTORY DCB    00113200
         USING IHADCB,R8               ESTABLISH ADDRESSABILITY TO DCB  00113300
         MVC   DIRECT(DIRECTL),DIRECTC MOVE DIRECTORY DCB CONSTANT INTO 00113400
*                                      DIRECTORY DCB IN WORKAREA        00113500
         L     R1,0(,R6)               GET ADDRESS OF DSNAME        WFB 00113600
         CLI   0(R1),C'*'              SEE IF DSNAME IS ASTERISK    WFB 00113700
         BNE   OPENDIR                 NO, GO OPEN INPUT DIRECTORY  WFB 00113800
         MVC   DCBDDNAM,PREALDDN       YES, USE PREALLOCATED DDN(.) WFB 00113900
OPENDIR  DS    0H                                                   WFB 00114000
         MVC   OPENLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00114100
*                                      INTO OPEN LIST IN WORKAREA       00114200
         OPEN  ((R8),INPUT),MF=(E,OPENLST)  OPEN DIRECTORY DCB          00114300
         TM    DCBOFLGS,DCBOFOPN       SEE IF DCB OPENED SUCCESSFULLY   00114400
         BNO   NOTPMESS                NO.....GO PUT OUT NOT PRINTED    00114500
*                                      MESSAGE                          00114600
         DROP  R8                      DROP ADDRESSABILITY TO DCB       00114700
*                                                                     * 00114800
*********************************************************************** 00114900
*                                                                     * 00115000
*        GETMAIN MEMBER TABLE FOR STORAGE OF DIRECTORY NAMES, ETC.    * 00115100
*           INITIALIZE TABLE                                          * 00115200
*                                                                     * 00115300
*********************************************************************** 00115400
*                                                                       00115500
         L     R0,MEMDATL              LOAD LENGTH OF GETMAIN FOR       00115600
*                                      MEMBER TABLE                     00115700
         LR    R2,R0                   SAVE IN REGISTER 2               00115800
         GETMAIN R,LV=(0)              GETMAIN MEMBER TABLE STORAGE     00115900
         ST    R1,MEMTABLE             SAVE ADDRESS OF MEMBER TABLE     00116000
         ST    R1,PRESENT              ALSO SAVE ADDRESS AS TABLE       00116100
*                                      IN USE                           00116200
         LA    R3,0(R2,R1)             LOAD ADDRESS OF END OF TABLE     00116300
         ST    R3,ENDTABLE             STORE ADDRESS OF TABLE END       00116400
         SLR   R4,R4                   ZERO REGISTER 4                  00116500
         ST    R4,0(R1)                STORE AS FIRST WORD OF MEMBER    00116600
*                                      TABLE                            00116700
         LA    R4,8(R1)                LOAD REGISTER 4 AS POINTER TO    00116800
*                                      THE FIRST ENTRY                  00116900
         USING MEMDSECT,R4             ESTABLISH ADDRESSABILITY TO      00117000
*                                      MEMBER TABLE DSECT               00117100
         SLR   R5,R5                   INITIALIZE MEMBER COUNT TO ZERO  00117200
*                                                                     * 00117300
*********************************************************************** 00117400
*                                                                     * 00117500
*        READ DIRECTORY AND BUILD MEMBER TABLE                        * 00117600
*                                                                     * 00117700
*********************************************************************** 00117800
*                                                                       00117900
GETDIR   EQU   *                                                        00118000
         GET   (R8),DATA               GET A DIRECTORY BLOCK            00118100
         CLC   DATA,HALF12             SEE IF BLOCK IS UNUSED           00118200
         BL    FREEBLK                 YES....GO HANDLE DIRECTORY END   00118300
         LA    R9,DATA+2               LOAD POINTER TO FIRST DIRECTORY  00118400
*                                      ENTRY                            00118500
         SLR   R7,R7                   ZERO REGISTER 7 FOR INSERT       00118600
         ICM   R7,3,DATA               INSERT LENGTH USED OF THIS BLOCK 00118700
         LA    R7,DATA-1(R7)           LOAD LAST USED BYTE OF BLOCK     00118800
UNBLOCK  DS    0H                                                       00118900
         MVC   MEMNTTR,0(R9)           PUT NAME AND TTR IN TABLE        00119000
         MVC   CFIELD,11(R9)           PUT C FIELD IN TABLE             00119100
         CLI   MEMBER,HEXFF            SEE IF LAST MEMBER               00119200
         BE    FREEBLK                 YES....GO HANDLE DIRECTORY END   00119300
         IC    R6,CFIELD               INSERT CFIELD INTO REGISTER 6    00119400
         SLL   R6,27                   SHIFT OUT HIGH ORDER BITS        00119500
         SRL   R6,26                   SHIFT RIGHT TO GET LENGTH OF     00119600
*                                      USER DATA                        00119700
         LA    R6,12(R6)               ADD STANDARD ENTRY LENGTH        00119800
         LA    R4,MEMSECTN             LOAD PINTER TO NEXT TABLE ENTRY  00119900
         LA    R5,1(R5)                INCREMENT NUMBER OF MEMBERS IN   00120000
*                                      TABLE                            00120100
         C     R4,ENDTABLE             SEE IF END OF TABLE              00120200
         BL    NEXTNTRY                LOW.....GO PROCESS NEXT ENTRY    00120300
         LR    R0,R2                   LOAD LENGTH OF TABLE FOR GETMAIN 00120400
         GETMAIN R,LV=(0)              GET NEXT TABLE                   00120500
         L     R14,PRESENT             LOAD REGISTER 14 WITH ADDRESS OF 00120600
*                                      LAST TABLE                       00120700
         ST    R1,0(R14)               CHAIN MEMBER TABLES TOGETHER     00120800
         ST    R1,PRESENT              ALSO SAVE ADDRESS AS TABLE       00120900
*                                      IN USE                           00121000
         LA    R3,0(R2,R1)             LOAD ADDRESS OF TABLE END        00121100
         ST    R3,ENDTABLE             STORE ADDRESS OF TABLE END       00121200
         SLR   R4,R4                   ZERO REGISTER 4                  00121300
         ST    R4,0(R1)                STORE AS FIRST WORD OF MEMBER    00121400
*                                      TABLE                            00121500
         LA    R4,8(R1)                LOAD REGISTER 4 AS POINTER TO    00121600
*                                      THE FIRST ENTRY                  00121700
         STH   R5,4(R14)               STORE MEMBER COUNT IN OLD TABLE  00121800
         SLR   R5,R5                   INITIALIZE MEMBER COUNT TO ZERO  00121900
NEXTNTRY DS    0H                                                       00122000
         BXLE  R9,R6,UNBLOCK           INCREMENT REGISTER 9 WITH        00122100
*                                      REGISTER 6 AND BRANCH            00122200
*                                      LESS THAN OR EQUAL TO            00122300
*                                      REGISTER 7 TO UNBLOCK            00122400
         B     GETDIR                  NO.....GO GET NEXT DIRECTORY     00122500
*                                      BLOCK                            00122600
         DROP  R4                      DROP ADDRESSABILITY TO TABLE     00122700
*                                                                       00122800
*********************************************************************** 00122900
*                                                                     * 00123000
*        LIST MEMBERS IF:                                             * 00123100
*           LIST SPECIFIED OR                                         * 00123200
*           BOTH PRINT AND NOLIST WERE NOT SPECIFIED                  * 00123300
*                                                                     * 00123400
*********************************************************************** 00123500
*                                                                       00123600
FREEBLK  DS    0H                                                       00123700
         MVC   OPENLST,OPENCLOS        MOVE CONSTANT INTO CLOSE LIST    00123800
         CLOSE ((R8),),MF=(E,OPENLST)  CLOSE DIRECTORY DCB              00123900
         L     R2,PRESENT              LOAD POINTER TO LAST TABLE       00124000
         STH   R5,4(R2)                STORE COUNT OF MEMBERS           00124100
         L     R4,MEMTABLE             LOAD POINTER TO FIRST TABLE      00124200
         CLC   4(2,R4),HALF0           SEE IF THERE WERE ANY MEMBERS    00124300
         BE    ENDMEMB                 ZERO...GO FREE MEMBER TABLE      00124400
         LA    R8,INPUT                LOAD POINTER TO INPUT DCB        00124500
         USING IHADCB,R8               ESTABLISH ADDRESSABILITY TO DCB  00124600
         MVC   INPUT(INPUTL),INPUTC    MOVE INPUT DCB CONSTANT INTO     00124700
*                                      INPUT DCB IN WORKAREA            00124800
         L     R1,SAVER6               GET SAVED ADDRESS OF DSN PDE WFB 00124900
         L     R1,0(,R1)               GET ADDRESS OF DSNAME        WFB 00125000
         CLI   0(R1),C'*'              SEE IF DSNAME IS ASTERISK    WFB 00125100
         BNE   OPENMEM                 NO, GO OPEN AGAIN FOR MEMBER WFB 00125200
         MVC   DCBDDNAM,PREALDDN       MOVE DDNAME INTO INPUT DCB   WFB 00125300
OPENMEM  DS    0H                                                   WFB 00125400
         MVC   OPENLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00125500
*                                      INTO OPEN LIST IN WORKAREA       00125600
         LA    R1,XLIST                LOAD ADDRESS OF EXIT LIST        00125700
         ST    R1,DCBEXLST             STORE ADDRESS OF EXIT LIST IN    00125800
*                                      DCB                              00125900
         LA    R1,SEXIT                LOAD ADDRESS OF EODAD EXIT       00126000
         ST    R1,DCBEODAD             STORE ADDRESS EODAD IN DCB       00126100
         LA    R2,JFCBAREA             LOAD ADDRESS OF JFCBAREA         00126200
         ST    R2,XLIST                STORE ADDRESS IN EXIT LIST       00126300
         MVI   XLIST,X'87'             SET END OF LIST AND JFCB BYTE    00126400
         MVC   RDJL,OPENCLOS           MOVE OPEN(CLOSE) LIST CONSTANT   00126500
*                                      INTO READJFCB LIST IN            00126600
*                                      WORKAREA                         00126700
         RDJFCB (INPUT,),MF=(E,RDJL)   READ JFCB INTO JFCBAREA          00126800
         MVC   JFCBELNM,8(R4)          MOVE MEMBER NAME INTO JFCB       00126900
         OI    JFCBIND1,JFCPDS         SET JFCB TO INDICATE PDS MEMBER  00127000
         MVI   JFCDSRG1,HEX00          SET JFCB TO REMOVE OTHER DSORG   00127100
*                                      INDICATORS                       00127200
         OPEN  ((R8),INPUT),TYPE=J,MF=(E,OPENLST)  OPEN INPUT DCB       00127300
         L     R9,PARSBACK             LOAD ADDRESS PARS ANSWER         00127400
         USING IKJPARMD,R9             ESTABLISH ADDRESSABILITY TO PDL  00127500
         CLC   PLIST,HALF2             SEE IF NOLIST SPECIFIED          00127600
         BE    NOLIST                  YES....SKIP LISTING              00127700
         CLC   PLIST,HALF1             SEE IF LIST SPECIFIED            00127800
         BE    LISTIT                  YES....GO LISTIT                 00127900
         CLC   PPRINT,HALF1            SEE IF PRINT SPECIFIED           00128000
         BE    NOLIST                  YES....SKIP LISTING              00128100
         DROP  R9                      DROP ADDRESSABILITY TO PDL       00128200
LISTIT   DS    0H                                                       00128300
         MVC   HEADER,HEADERM          MOVE HEADER INTO DATA AREA       00128400
         TM    DCBRECFM,DCBRECCM       SEE IF CONTROL IS MACHINE        00128500
         DROP  R8                      DROP ADDRESSABILITY TO DCB       00128600
         BNO   SUSEA                   NO.....GO TO USE ASA CONTROL     00128700
         LA    R5,OUTPUTM              LOAD ADDRESS OF OUTPUT DCB FOR   00128800
*                                      MACHINE CODE                     00128900
         LA    R4,EJECTM               LOAD ADDRESS OF EJECT DATA       00129000
         MVI   HDRCNTL,SKIPM           MOVE INTO HEADER MACHINE CODE    00129100
*                                      FOR SPACE                        00129200
         TM    48(R5),DCBOFOPN         SEE IF DCB IS ALREADY OPEN       00129300
         BO    SPUTDSN                 YES....GO PUT OUT HEADERS        00129400
         LA    R3,PRINTM               LOAD POINTER TO PRINTM           00129500
         LA    R14,SPUTDSN             LOAD ADDRESS FOR RETURN FROM     00129600
*                                      SYSOUT ALLOCATION                00129700
         B     ALLOCOUT                GO TO ALLOCATE SYSOUT            00129800
SUSEA    DS    0H                                                       00129900
         LA    R5,OUTPUTA              LOAD ADDRESS OF OUTPUT DCB FOR   00130000
*                                      ASA CODE                         00130100
         LA    R4,EJECTA               LOAD ADDRESS OF EJECT DATA       00130200
         TM    48(R5),DCBOFOPN         SEE IF DCB IS ALREADY OPEN       00130300
         BO    SPUTDSN                 YES....GO PUT OUT HEADERS        00130400
         LA    R3,PRINTA               LOAD POINTER TO PRINTA           00130500
         BAL   R14,ALLOCOUT            LOAD ADDRESS FOR RETURN AND GO   00130600
*                                      DO SYSOUT ALLOCATION             00130700
SPUTDSN  DS    0H                                                       00130800
         PUT   (R5),(R4)               PUT OUT PAGE EJECT               00130900
         PUT   (R5),HEADER             PUT OUT PAGE 1 HEADER            00131000
         MVC   HEADER2,LDSNAME         MOVE LENGTH AND 'DSNAME=' INTO   00131100
*                                      INTO SECOND HEADER               00131200
         MVC   HEADER2+4(1),HDRCNTL    MOVE IN CONTROL BYTE             00131300
         MVI   OPENPRN,BLANK           BLANK OUT MEMBER NAME            00131400
         MVC   MEMNAME(9),OPENPRN      FINISH BLANKING OUT MEMBER NAME  00131500
         PUT   (R5),HEADER2            PUT OUT PAGE 1 HEADER 2          00131600
         L     R2,MEMTABLE             LOAD ADDRESS OF FIRST TABLE      00131700
         MVC   LENGTH,HALF85           SET LENGTH TO 85 BYTES           00131800
         MVC   LENGTH+2,HALF0          ZERO RESERVED BYTES              00131900
         MVC   CNTLBYTE,HDRCNTL        MOVE IN HEADER CONTROL BYTE      00132000
*                                                                       00132100
*********************************************************************** 00132200
*                                                                     * 00132300
*        LIST MEMBER NAMES                                            * 00132400
*                                                                     * 00132500
*********************************************************************** 00132600
*                                                                       00132700
SCROLLER DS    0H                                                       00132800
         LA    R10,50                  LOAD LINE COUNT                  00132900
         ST    R2,PRESENT              SAVE ADDRESS OF CURRENT TABLE    00133000
         LH    R7,4(R2)                LOAD NUMBER OF MEMBERS IN TABLE  00133100
         LTR   R7,R7                   SEE IF THERE ARE ENTRIES         00133200
         BZ    NOLIST                  NO.....GO PRINT MEMBERS          00133300
         LA    R2,8(R2)                LOAD ADDRESS OF FIRST MEMBER     00133400
         USING MEMDSECT,R2             ESTABLISH ADDRESSABILITY TO      00133500
*                                      MEMBER TABLE ENTRY               00133600
LOOP1    DS    0H                                                       00133700
         LA    R6,DATA                 LOAD ADDRESS OF OUTPUT BUFFER    00133800
         MVI   DATA,BLANK              BLANK OUT OUTPUT BUFFER          00133900
         MVC   DATA+1(79),DATA         FINISH BLANKING BUFFER           00134000
         TM    CFIELD,HIGH             SEE IF THIS IS AN ALIAS          00134100
         BZ    NOTALIAS                NO.....CONTINUE WITH MAIN NAME   00134200
         BAL   R14,LOOKLOOP            GO LOOK FOR MAIN NAME            00134300
NOTALIAS DS    0H                                                       00134400
         MVC   2(8,R6),MEMBER          PUT MEMBER NAME IN OUTPUT BUFFER 00134500
         ST    R2,SAVER2               SAVE REGISTER 2                  00134600
         LA    R3,2                    LOAD NUMBER OF COLUMNS LEFT      00134700
         LA    R8,1                    LOAD ENTRY NUMBER                00134800
LOOP2    LA    R8,50(R8)               LOAD POINTER TO NEXT COLUMN      00134900
*                                      ENTRY                            00135000
         CR    R8,R7                   SEE IF VALID ENTRY               00135100
         BH    END2                    NO.....GO PRINT LINE             00135200
         LA    R2,600(R2)              LOAD POINTER TO MEMBER NAME      00135300
         LA    R6,30(R6)               LOAD POINTER TO NEXT OUTPUT      00135400
*                                      BUFFER LOCATION                  00135500
         TM    CFIELD,HIGH             SEE IF THIS IS AN ALIAS          00135600
         BZ    NOTAL2                  NO.....CONTINUE WITH MAIN NAME   00135700
         BAL   R14,LOOKLOOP            GO LOOK FOR MAIN NAME            00135800
NOTAL2   DS    0H                                                       00135900
         MVC   2(8,R6),MEMBER          PUT MEMBER NAME IN OUTPUT BUFFER 00136000
         BCT   R3,LOOP2                DECREMENT COLUMN COUNT           00136100
END2     DS    0H                                                       00136200
         PUT   (R5),LINE               PUT OUT OUTPUT LINE              00136300
         L     R2,SAVER2               RELOAD REGISTER 2                00136400
         LA    R2,MEMSECTN             LOAD POINTER TO NEXT MEMBER NAME 00136500
         BCT   R10,MOREROW             DECREMENT ROW COUNT              00136600
         PUT   (R5),(R4)               PUT OUT PAGE EJECT WHEN ZERO     00136700
         B     LOOP3                   RESET COUNTERS                   00136800
MOREROW  DS    0H                                                       00136900
         BCT   R7,LOOP1                DECREMENT MEMBER COUNT FOR       00137000
*                                      CURRENT TABLE                    00137100
LOOP3    L     R2,PRESENT              LOAD POINTER TO CURRENT TABLE    00137200
         L     R2,0(R2)                LOAD POINTER TO NEXT TABLE       00137300
         LTR   R2,R2                   SEE IF IT WAS THE LAST TABLE     00137400
         BNZ   SCROLLER                NO.....GO LIST OUT NEXT TABLE    00137500
*                                                                       00137600
*********************************************************************** 00137700
*                                                                     * 00137800
*        PRINT MEMBERS IF:                                            * 00137900
*           PRINT SPECIFIED OR                                        * 00138000
*           BOTH LIST AND NOPRINT WERE NOT SPECIFIED                  * 00138100
*                                                                     * 00138200
*********************************************************************** 00138300
*                                                                       00138400
NOLIST   DS    0H                                                       00138500
         L     R9,PARSBACK             LOAD ADDRESS PARS ANSWER         00138600
         USING IKJPARMD,R9             ESTABLISH ADDRESSABILITY TO PDL  00138700
         CLC   PPRINT,HALF2            SEE IF NOPRINT SPECIFIED         00138800
         BE    ENDMEMB                 YES....GO SKIP PRINT             00138900
         CLC   PPRINT,HALF1            SEE IF PRINT SPECIFIED           00139000
         BE    CONTPRT                 YES....GO PRINT MEMBERS          00139100
         CLC   PLIST,HALF1             SEE IF LIST SPECIFIED            00139200
         BE    ENDMEMB                 YES....GO SKIP PRINT             00139300
         DROP  R9                      DROP ADDRESSABILITY TO PDL       00139400
CONTPRT  DS    0H                                                       00139500
         L     R6,SAVER6               RESTORE REGISTER 6               00139600
         LA    R8,INPUT                LOAD ADDRESS OF INPUT DCB        00139700
         USING IHADCB,R8               ESTABLISH ADDRESSABILITY TO DCB  00139800
         MVC   CLOSLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00139900
*                                      INTO CLOSE LIST IN WORKAREA      00140000
         CLOSE ((R8),),MF=(E,CLOSLST)  CLOSE INPUT DCB                  00140100
         DROP  R8                      DROP ADDRESSABILITY TO INPUT DCB 00140200
         TM    VOLBIT,NOMSG            IS NOMSG SPECIFIED ?         WFB 00140300
         BO    NOMEMMSG                YES, SKIP MEMBER MESSAGE     WFB 00140400
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00140500
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00140600
         PUTLINE OUTPUT=(PRTMSG,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT   00140700
*                                      DATASET PRINT MESSAGE            00140800
         DROP  R15                                                  WFB 00140900
         LH    R4,DFPBDSL              LOAD LENGTH OF DSNAME       GTEL 00141000
         A     R4,FULL4                INCREMENT LENGTH FOR PUTLINE     00141100
         SLL   R4,16                   SHIFT LENGTH TO HIGH ORDER BYTES 00141200
         STCM  R4,15,DSNLENP           STORE LENGTH OF PUTLINE          00141300
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00141400
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00141500
         PUTLINE OUTPUT=(DSNLENP,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT  00141600
*                                      DATA SET NAME MESSAGE            00141700
         DROP  R15                                                  WFB 00141800
NOMEMMSG DS    0H                                                   WFB 00141900
         L     R2,MEMTABLE             LOAD ADDRESS OF FIRST MEMBER     00142000
*                                      TABLE                            00142100
         LH    R3,4(R2)                LOAD NUMBER OF MEMBERS IN TABLE  00142200
         LTR   R3,R3                   SEE IF THERE ARE ANY MEMBERS     00142300
         BZ    ENDMEMB                 NO.....GO TO END OF SCROLLER     00142400
         ST    R2,PRESENT              SAVE ADDRESS OF CURRENT TABLE    00142500
         LA    R2,8(R2)                LOAD POINTER TO MEMBER NAME      00142600
NEXTMEMB DS    0H                                                       00142700
         TM    CFIELD,HIGH             SEE IF THIS IS AN ALIAS ENTRY    00142800
         BO    AGAIN                   YES....DO NOT PRINT IT           00142900
PRINTMEM DS    0H                                                       00143000
         MVC   MEMNAME,MEMBER          MOVE MEMBER NAME INTO HEADER     00143100
         MVC   JFCBELNM,MEMBER         MOVE MEMBER NAME INTO JFCBAREA   00143200
         MVC   OPENLST,OPENCLOS        MOVE CONSTANT INTO OPEN LIST     00143300
         OPEN  ((R8),INPUT),TYPE=J,MF=(E,OPENLST)                       00143400
*                                      OPEN INPUT DCB                   00143500
         STM   R2,R3,SAVER2            SAVE REGISTERS 2 AND 3           00143600
         B     PRINTS                  GO PRINT MEMBER                  00143700
SEXIT    DS    0H                                                       00143800
         LM    R2,R3,SAVER2            RESTORE REGISTERS 2 AND 3        00143900
         MVC   CLOSLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00144000
*                                      INTO CLOSE LIST IN WORKAREA      00144100
         CLOSE ((R8),),MF=(E,CLOSLST)  CLOSE INPUT DCB                  00144200
AGAIN    DS    0H                                                       00144300
         LA    R2,MEMSECTN             LOAD ADDRESS OF NEXT MEMBER      00144400
         BCT   R3,NEXTMEMB             BRANCH TO HANDLE NEXT MEMBER     00144500
         L     R14,PRESENT             ZERO...LOAD CURRENT TABLE        00144600
*                                      ADDRESS                          00144700
         L     R2,0(R14)               LOAD ADDRESS OF NEXT TABLE       00144800
         LTR   R2,R2                   SEE IF ZERO, LAST TABLE          00144900
         BZ    ENDMEMB                 NO.....GO HANDLE END OF MEMBERS  00145000
         ST    R2,PRESENT              SAVE ADDRESS OF CURRENT TABLE    00145100
         LH    R3,4(R2)                LOAD NUMBER OF MEMBERS IN NEXT   00145200
*                                      TABLE                            00145300
         LTR   R3,R3                   SEE IF ANY MEMBERS IN TABLE      00145400
         BZ    ENDMEMB                 NO.....GO HANDLE END OF MEMBERS  00145500
         LA    R2,8(R2)                LOAD POINTER TO MEMBER NAME      00145600
         B     NEXTMEMB                GO GET NEXT MEMBER               00145700
ENDMEMB  DS    0H                                                       00145800
         L     R2,MEMTABLE             LOAD POINTER TO FIRST TABLE      00145900
FREETABS DS    0H                                                       00146000
         LR    R1,R2                   LOAD AREA TO BE FREED            00146100
         L     R2,0(R2)                LOAD POINTER TO NEXT TABLE       00146200
         L     R0,MEMDATL              LOAD SIZE OF AREA TO BE FREED    00146300
         FREEMAIN R,LV=(0),A=(1)       FREE STORAGE GETMAINED FOR TABLE 00146400
         LTR   R2,R2                   SEE IF THERE WAS ANOTHER TABLE   00146500
         BNZ   FREETABS                YES....GO FREE NEXT TABLE        00146600
         L     R6,SAVER6               RESTORE REGISTER 6               00146700
         LA    R8,INPUT                LOAD POINTER TO INPUT DCB        00146800
         USING IHADCB,R8               ESTABLISH ADDRESSABILITY TO DCB  00146900
         TM    DCBOFLGS,DCBOFOPN       SEE IF INPUT DCB IS STILL OPEN   00147000
         BNO   EXITMSG                 NO.....GO HANDLE NEXT DATASET    00147100
         MVC   CLOSLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00147200
*                                      INTO CLOSE LIST IN WORKAREA      00147300
         CLOSE ((R8),),MF=(E,CLOSLST)  CLOSE INPUT DCB                  00147400
         DROP  R8                      DROP ADDRESSABILITY TO DCB       00147500
         B     EXITMSG                 GO HANDLE NEXT DATASET           00147600
*                                                                     * 00147700
*********************************************************************** 00147800
*                                                                     * 00147900
*        PUT OUT SYNAD ERROR MESSAGE,                                 * 00148000
*           GO FREE MEMBER TABLES, AND                                * 00148100
*           CONTINUE WITH NEXT DATASET                                * 00148200
*                                                                     * 00148300
*********************************************************************** 00148400
*                                                                       00148500
SERRI    DS    0H                                                       00148600
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00148700
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00148800
         PUTLINE OUTPUT=(SYNADI,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT   00148900
*                                      DATASET NOT PRINTED DUE TO SYNAD 00149000
*                                      ERROR ON INPUT DATASET MESSAGE   00149100
         DROP  R15                                                  WFB 00149200
         B     ENDMEMB                 GO FREE MEMBER TABLES            00149300
*                                                                     * 00149400
*********************************************************************** 00149500
*                                                                     * 00149600
*        SEARCH FOR MAIN NAME,                                        * 00149700
*           SAME TTR AND NOT AN ALIAS                                 * 00149800
*                                                                     * 00149900
*********************************************************************** 00150000
*                                                                       00150100
LOOKLOOP DS    0H                                                       00150200
         STM   R3,R4,SAVER3            SAVE REGISTERS 3 AND 4           00150300
         L     R3,MEMTABLE             LOAD ADDRESS OF FIRST TABLE      00150400
         USING MEMDSECT,R3             ESTABLISH ADDRESSABILITY TO      00150500
*                                      MEMBER ENTRY                     00150600
LOOP4    DS    0H                                                       00150700
         ST    R3,CURRENT              SAVE ADDRESS OF PRESENT TABLE    00150800
         LH    R4,4(R3)                LOAD NUMBER OF ELEMENTS IN TABLE 00150900
         LTR   R4,R4                   SEE IF THERE ARE ZERO ELEMENTS   00151000
         BZ    NOMAIN                  YES....GO HANDLE MAIN NOT FOUND  00151100
         LA    R3,8(R3)                LOAD ADDRESS OF FIRST MEMBER     00151200
LOOP5    DS    0H                                                       00151300
         CLC   MEMTTR,8(R2)            SEE IF TTRS ARE THE SAME         00151400
         BE    SAMETTR                 YES....GO SEE IF IT IS AN ALIAS  00151500
ENDLP5   DS    0H                                                       00151600
         LA    R3,MEMSECTN             LOAD ADDRESS OF NEXT MEMBER      00151700
         BCT   R4,LOOP5                DECREMENT MEMBER COUNT           00151800
         L     R3,CURRENT              LOAD ADDRESS OF THIS TABLE       00151900
         L     R3,0(R3)                LOAD ADDRESS OF NEXT TABLE       00152000
         LTR   R3,R3                   SEE IF IT WAS THE LAST TABLE     00152100
         BNZ   LOOP4                   NO.....GO CHECK NEXT TABLE       00152200
         B     NOMAIN                  GO HANDLE MAIN NOT FOUND         00152300
SAMETTR  DS    0H                                                       00152400
         TM    CFIELD,HIGH             SEE IF THIS IS ALSO AN ALIAS     00152500
         BO    ENDLP5                  YES....GO LOOK FOR ANOTHER TTR   00152600
         MVC   11(8,R6),MEMBER         MOVE MEMBER NAME INTO OUTPUT     00152700
         B     ENDLOOK                 GO TO RETURN TO CALLER           00152800
NOMAIN   DS    0H                                                       00152900
         MVC   11(8,R6),ALIAS          INDICATE THIS IS AN ALIAS        00153000
ENDLOOK  DS    0H                                                       00153100
         LM    R3,R4,SAVER3            RESTORE REGISTERS 3 AND 4        00153200
         BR    R14                     RETURN TO CALLER                 00153300
         DROP  R3                      DROP ADDRESSABILITY TO TABLE     00153400
*                                                                       00153500
CONTINUE DS    0H                                                       00153600
         L     R1,0(,R6)               GET ADDRESS OF DSNAME        WFB 00153700
         CLI   0(R1),C'*'              SEE IF DSNAME IS ASTERISK    WFB 00153800
         BE    CLOSDCBS                YES, DO NOT FOLLOW CHAIN     WFB 00153900
         L     R6,24(R6)               LOAD POINTER TO NEXT DSNAME ON   00154000
*                                      CHAIN                            00154100
         C     R6,ENDCHAIN             SEE IF END OF CHAIN IS REACHED   00154200
         BNE   NEXT                    NO.....GO DO NEXT DATASET NAME   00154300
CLOSDCBS DS    0H                                                       00154400
         TM    INPUT+48,DCBOFOPN       SEE IF INPUT DCB IS STILL OPEN   00154500
         BNO   CHKOUTA                 NO.....GO CHECK DCB FOR ASA CODE 00154600
         MVC   CLOSLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00154700
*                                      INTO CLOSE LIST WORKAREA         00154800
         LA    R5,INPUT                LOAD POINTER TO INPUT DCB        00154900
         CLOSE ((R5),),MF=(E,CLOSLST)  CLOSE INPUT DCB                  00155000
         L     R1,0(,R6)               GET ADDRESS OF DSNAME        WFB 00155100
         CLI   0(R1),C'*'              SEE IF DSNAME IS ASTERISK    WFB 00155200
         BE    CHKOUTA                 YES, DO NOT FREE DDN(...)    WFB 00155300
         LA    R1,PRINTI               FREE INPUT DATASET          GTEL 00155400
         BAL   R2,FREEDD               FREE INPUT DATASET          GTEL 00155500
CHKOUTA  DS    0H                                                       00155600
         TM    OUTPUTA+48,DCBOFOPN     SEE IF OUTPUT DCB FOR ASA WAS    00155700
*                                      OPENED                           00155800
         BNO   CHKOUTM                 NO.....GO CHECK DCB FOR MACHINE  00155900
*                                      CODE                             00156000
         MVC   CLOSLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00156100
*                                      INTO CLOSE LIST WORKAREA         00156200
         LA    R5,OUTPUTA              LOAD POINTER TO ASA CODE DCB     00156300
         TM    VOLBIT,UDKDONE          WERE UDKS WRITTEN ?          WFB 00156400
         BZ    CLOSEA                  NO, GO CLOSE                 WFB 00156500
         PUT   (R5),UDKRESET           PUT OUT UDK RESET TEXT       WFB 00156600
         NI    VOLBIT,UDKDONE          TURN OFF UDK WRITTEN FLAG    WFB 00156700
CLOSEA   DS    0H                                                   WFB 00156800
         CLOSE ((R5),),MF=(E,CLOSLST)  CLOSE ASA CODE OUTPUT DCB        00156900
         LA    R1,PRINTA               LOAD ADDRESS OF PRINT DDNAME     00157000
         BAL   R2,FREEDD               GO FREE ASA CODE OUTPUT DDNAME   00157100
CHKOUTM  DS    0H                                                       00157200
         TM    OUTPUTM+48,DCBOFOPN     SEE IF OUTPUT DCB FOR MACHINE    00157300
*                                      CODE WAS OPENED                  00157400
         BNO   RETURN                  NO.....GO FREE GETMAINED AREAS   00157500
*                                      AND RETURN                       00157600
         MVC   CLOSLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00157700
*                                      INTO CLOSE LIST WORKAREA         00157800
         LA    R5,OUTPUTM              LOAD POINTER TO MACHINE CODE DCB 00157900
         TM    VOLBIT,UDKDONE          WERE UDKS WRITTEN ?          WFB 00158000
         BZ    CLOSEM                  NO, GO CLOSE                 WFB 00158100
         PUT   (R5),UDKRESET           PUT OUT UDK RESET TEXT       WFB 00158200
         NI    VOLBIT,UDKDONE          TURN OFF UDK WRITTEN FLAG    WFB 00158300
CLOSEM   DS    0H                                                   WFB 00158400
         CLOSE ((R5),),MF=(E,CLOSLST)  CLOSE MACHINE CODE OUTPUT DCB    00158500
         LA    R1,PRINTM               LOAD ADDRESS OF PRINT DDNAME     00158600
         BAL   R2,FREEDD               GO FREE MACHINE CODE OUTPUT      00158700
*                                      DDNAME                           00158800
*                                                                       00158900
*********************************************************************** 00159000
*                                                                     * 00159100
*        CLEANUP AREAS GETMAINED BY PARS,                             * 00159200
*           SET RETURN CODE, RESTORE REGISTERS AND                    * 00159300
*           RETURN TO CALLER                                          * 00159400
*                                                                     * 00159500
*********************************************************************** 00159600
*                                                                       00159700
RETURN   DS    0H                                                       00159800
         IKJRLSA PARSBACK              RELEASE AREAS GETMAINED BY PARS  00159900
         L     R1,ALNDSECT                                              00160000
         FREEMAIN R,LV=RECSIZE,A=(1)                                WFB 00160100
         LR    R1,R13                  LOAD ADDRESS OF GETMAINED AREA   00160200
         L     R13,4(,R13)             RELOAD ADDRESS OF PREVIOUS SAVE  00160300
*                                      AREA                             00160400
         LA    R0,LDYNAMIC             LOAD LENGTH OF GETMAINED AREA    00160500
         FREEMAIN R,LV=(0),A=(1)       FREE GETMAINED AREA              00160600
         SLR   R15,R15                 ZERO REGISTER 15.  RETURN CODE   00160700
*                                      CODE WILL ALWAYS BE ZERO         00160800
         L     R14,12(,R13)            LOAD REGISTER 14 WITH RETURN     00160900
*                                      ADDRESS                          00161000
         LM    R0,R12,20(R13)          RESTORE REGISTERS                00161100
         BR    R14                     RETURN                           00161200
*                                                                       00161300
*********************************************************************** 00161400
*                                                                     * 00161500
*        ROUTINE TO CONVERT NONZERO RETURN CODES TO DECIMAL           * 00161600
*           FOR DISPLAY                                               * 00161700
*                                                                     * 00161800
*********************************************************************** 00161900
*                                                                       00162000
SETCODE  DS    0H                                                       00162100
         CVD   R8,DEC                  CONVERT RETURN CODE TO DECIMAL   00162200
         UNPK  CONV(8),DEC(8)          UNPACK RETURN CODE               00162300
         MVZ   CONV+1(7),CONV          MOVE ZONES IN CONVERTED RETURN   00162400
*                                      CODE                             00162500
         MVC   RETNCD(2),HALF12        MOVE LENGTH OF DATA FOR PUTLINE  00162600
         MVC   RETNCD+2(2),HALF0       MOVE IN ZEROES FOR PUTLINE       00162700
         BR    R14                     RETURN                           00162800
*                                                                       00162900
*********************************************************************** 00163000
*                                                                     * 00163100
*        FREE AND REALOCATE PRINTX FILE AS SYSOUT                     * 00163200
*                                                                     * 00163300
*********************************************************************** 00163400
*                                                                       00163500
ALLOCOUT DS    0H                                                       00163600
         STM   14,9,ALCSAVE            SAVE WORK REGISTERS              00163700
*---------------------------------------------------------------------* 00163800
*------------------------- START OF ARAMCO MOD -----------------------* 00163900
*---------------------------------------------------------------------* 00164000
         MVC   SETPRTE(SETPRTEL),SETPRTL MOVE SETPRT LIST               00164100
         MVI   SETFLAG,X'00'             AND CLEAR FLAG                 00164200
*---------------------------------------------------------------------* 00164300
*--------------------------- END OF ARAMCO MOD -----------------------* 00164400
*---------------------------------------------------------------------* 00164500
         LR    R1,R3                   LOAD POINTER TO DDNAME           00164600
         BAL   R2,FREEDD               BRANCH TO FREE ROUTINE           00164700
         LTR   R8,R8                   SEE IF RETURN CODE FROM FREE IS  00164800
*                                      ZERO                             00164900
         BNZ   OPENFAIL                NO.....GO PUT OUT OPEN FAILED    00165000
         LA    R8,REQBLK               LOAD POINTER TO REQUEST BLOCK    00165100
         ST    R8,RBPTR                INITIALIZE REQUEST BLOCK POINTER 00165200
         MVI   RBPTR,S99RBPND          INDICATE END OF PARAMETER LIST   00165300
         USING S99RB,R8                ESTABLISH ADDRESSABILITY TO      00165400
*                                      REQUEST BLOCK                    00165500
         MVC   S99RBLN(RBLEN),REQBLKC  INITALIZE RB                     00165600
         LA    R1,TEXTPTRS             LOAD POINTER TO TEXT POINTERS    00165700
         ST    R1,S99TXTPP             STORE POINTER IN RB              00165800
         DROP  R8                      DROP ADDRESSABILITY TO RB        00165900
         USING S99TUPL,R1              ESTABLISH ADDRESSABILITY TO      00166000
*                                      TEXT UNIT POINTER LIST           00166100
         LA    R2,TEXTA                LOAD POINTER TO FIRST TEXT UNIT  00166200
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00166300
         USING S99TUNIT,R2             ESTABLISH ADDRESSABILITY TO      00166400
*                                      TEXT UNIT                        00166500
         MVC   S99TUKEY(TEXTALEN),TEXTAC  INITIALIZE TEXT UNIT A        00166600
         MVC   S99TUPAR(8),0(R3)       MOVE IN PARAMETER (DDNAME)       00166700
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00166800
*                                      POINTER                          00166900
         LA    R2,TEXTB                LOAD POINTER TO TEXT UNIT B      00167000
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00167100
         MVC   S99TUKEY(TEXTBLEN),TEXTBC  INITIALIZE TEXT UNIT B        00167200
*                                                                       00167300
*********************************************************************** 00167400
*                                                                     * 00167500
*        SET UP ADDRESSABILITY TO PDL                                 * 00167600
*           AND SEE IF SYSOUT CLASS/DEST ARE PRESENT                  * 00167700
*           ALSO FORMS/TRAIN/FCB/PROG.                             GTEL 00167800
*********************************************************************** 00167900
*                                                                       00168000
         L     R9,PARSBACK             LOAD ADDRESS PARS ANSWER         00168100
         USING IKJPARMD,R9             ESTABLISH ADDRESSABILITY TO PDL  00168200
         CLC   PCLASS(2),HALF1         SEE IF CLASS SPECIFIED           00168300
         BNE   NOCLASS                 NO.....GO CHECK FOR DESTINATION  00168400
         L     R7,SCLASS               LOAD POINTER TO SYSOUT CLASS     00168500
         MVC   S99TUPAR,0(R7)          MOVE CLASS INTO TEXT UNIT B      00168600
NOCLASS  DS    0H                                                       00168700
         CLC   PDEST(2),HALF1          SEE IF DEST SPECIFIED            00168800
         BNE   NODEST                  NO.....GO CHECK FOR HOLD         00168900
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00169000
*                                      POINTER                          00169100
         LA    R2,TEXTC                LOAD POINTER TO TEXT UNIT C      00169200
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00169300
         MVC   S99TUKEY(TEXTCLEN),TEXTCC  INITIALIZE TEXT UNIT C        00169400
         L     R7,SDEST                LOAD POINTER TO DESTINATION      00169500
         CLI   NODELEN+1,0             IS NODE.USERID SPECIFIED ?   WFB 00169600
         BZ    NONODE                  NO, USE TOTAL LENGTH         WFB 00169700
         LH    R6,NODELEN              YES, USE NODE LENGTH         WFB 00169800
         STH   R6,S99TULNG             STORE LENGTH OF DEST IN TU   WFB 00169900
         BCTR  R6,0                    DECREMENT LENGTH FOR EXECUTE WFB 00170000
         EX    R6,MOVEDEST             MOVE NODE INTO TEXT UNIT     WFB 00170100
         LA    R1,4(,R1)               POINT NEXT TEXT UNIT POINTER WFB 00170200
         LA    R2,TEXTK                ADDRESS TEXT UNIT K - USERID WFB 00170300
         ST    R2,S99TUPTR             STORE ADDRESS IN TUPL        WFB 00170400
         MVC   S99TUKEY(TEXTKLEN),TEXTKC  INITIALIZE TEXT UNIT K    WFB 00170500
         LA    R7,2(R6,R7)             POINT PAST 'NODE.' TO USERID WFB 00170600
         LH    R6,SDEST+4              GET TOTAL LENGTH             WFB 00170700
         SH    R6,NODELEN              MINUS NODE LENGTH            WFB 00170800
         SH    R6,HALF2                MINUS 1 FOR DOT, 1 EXECUTE   WFB 00170900
         EX    R6,MOVEDEST             MOVE USERID INTO TEXT UNIT   WFB 00171000
         B     NODEST                                               WFB 00171100
NONODE   DS    0H                                                   WFB 00171200
         LH    R6,SDEST+4              LOAD LENGTH OF DESTINATION ID    00171300
         STH   R6,S99TULNG             STORE LENGTH OF DEST IN TU       00171400
         BCTR  R6,0                    DECREMENT LENGTH FOR EXECUTE OF  00171500
*                                      MOVE                             00171600
         EX    R6,MOVEDEST             MOVE DEST INTO TU                00171700
MOVEDEST MVC   S99TUPAR,0(R7)          MOVE TO BE EXECUTED              00171800
*                                                                       00171900
NODEST   DS    0H                                                       00172000
         CLC   PHOLD(2),HALF1          SEE IF HOLD SPECIFIED            00172100
         BNE   NOHOLD                  NO.....GO CHECK FOR COPIES       00172200
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00172300
*                                      POINTER                          00172400
         LA    R2,TEXTDC               LOAD POINTER TO TEXT UNIT C      00172500
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00172600
NOHOLD   DS    0H                                                       00172700
         CLC   PCOPIES(2),HALF1        SEE IF COPY SPECIFIED            00172800
         BNE   NOCOPY                  NO.....GO ZERO ECB               00172900
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00173000
*                                      POINTER                          00173100
         LA    R2,TEXTE                LOAD POINTER TO TEXT UNIT E      00173200
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00173300
         MVC   S99TUKEY(TEXTELEN),TEXTEC  INITIALIZE TEXT UNIT E        00173400
         L     R7,SCOPIES              LOAD POINTER TO COPY FIELD       00173500
         LH    R6,SCOPIES+4            LOAD LENGTH OF COPY FIELD        00173600
         BCTR  R6,0                    DECREMENT REGISTER 6 FOR EXECUTE 00173700
*                                      OF PACK INSTRUCTION              00173800
         EX    R6,PACKCOPY             EXECUTE PACK TO CONVERT COPIES   00173900
*                                      TO ZONED DECIMAL                 00174000
         CVB   R6,DEC                  CONVERT ZONED TO BINARY          00174100
         STCM  R6,1,S99TUPAR           STORE NUMBER OF COPIES IN TU     00174200
NOCOPY   DS    0H                                                       00174300
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00174400
**************************** START OF GTEL MOD ************************ 00174500
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00174600
         CLC   PFORMS(2),HALF1         SEE IF FORMS SPECIFIED           00174700
         BNE   NOFORMS                 NO.....GO CHECK TRAIN            00174800
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00174900
*                                      POINTER                          00175000
         LA    R2,TEXTI                LOAD POINTER TO TEXT UNIT I      00175100
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00175200
         MVC   S99TUKEY(TEXTILEN),TEXTIC  INITIALIZE TEXT UNIT I        00175300
         L     R7,RFORMS               LOAD POINTER TO FORMS FIELD      00175400
         LH    R6,RFORMS+4             LOAD LENGTH OF FORMS FIELD       00175500
         STH   R6,S99TULNG             STORE LENGTH IN TUE              00175600
         BCTR  R6,0                    DECREMENT LENGTH                 00175700
         EX    R6,MOVEDEST             MOVE FORMS INTO FIELD            00175800
NOFORMS  DS    0H                                                       00175900
         CLC   PTRAIN(2),HALF1         SEE IF TRAIN SPECIFIED           00176000
         BNE   NOTRAIN                 NO.....GO CHECK FCB              00176100
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00176200
*                                      POINTER                          00176300
         LA    R2,TEXTH                LOAD POINTER TO TEXT UNIT G      00176400
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00176500
         MVC   S99TUKEY(TEXTHLEN),TEXTHC  INITIALIZE TEXT UNIT H        00176600
         L     R7,RTRAIN               LOAD POINTER TO TRAIN FIELD      00176700
         LH    R6,RTRAIN+4             LOAD LENGTH OF TRAIN FIELD       00176800
         STH   R6,S99TULNG             SAVE LENGTH OF FCBE              00176900
         BCTR  R6,0                    DECREMENT FOR EX                 00177000
         EX    R6,MOVEDEST             MOVE FCB INTO TU                 00177100
NOTRAIN  DS    0H                                                       00177200
         CLC   PFCB(2),HALF1           SEE IF FCB  SPECIFIED            00177300
         BNE   NOFCB                   NO.....GO ZERO ECB               00177400
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00177500
*                                      POINTER                          00177600
         LA    R2,TEXTG                LOAD POINTER TO TEXT UNIT G      00177700
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00177800
         MVC   S99TUKEY(TEXTGLEN),TEXTGC  INITIALIZE TEXT UNIT G        00177900
         L     R7,RFCB                 LOAD POINTER TO FCB FIELD        00178000
         LH    R6,RFCB+4               LOAD LENGTH OF FCB FIELD         00178100
         STH   R6,S99TULNG             SAVE LENGTH OF FCB IN TUE        00178200
         BCTR  R6,0                    DECREMENT                        00178300
         EX    R6,MOVEDEST             MOVE FCB TO TU                   00178400
NOFCB    DS    0H                                                       00178500
         CLC   PPROG(2),HALF1          SEE IF PROG SPECIFIED            00178600
         BNE   NOPROG                  NO.....GO ZERO ECB               00178700
         CLI   NODELEN+1,0             IS DEST(NODE.USERID) GIVEN ? WFB 00178800
         BH    NOPROG                  YES, IGNORE PROG             WFB 00178900
*                                      DYNALLOC TEXT UNITS FOR USER WFB 00179000
*                                      AND PROG ARE MUTUAL EXCLUSIV WFB 00179100
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00179200
*                                      POINTER                          00179300
         LA    R2,TEXTJ                LOAD POINTER TO TEXT UNIT J      00179400
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00179500
         MVC   S99TUKEY(TEXTJLEN),TEXTJC  INITIALIZE TEXT UNIT J        00179600
         L     R7,RPROG                LOAD POINTER TO PROG FIELD       00179700
         LH    R6,RPROG+4              LOAD LENGTH OF PROG FIELD        00179800
         STH   R6,S99TULNG             SAVE LENGTH OF PROG IN TUE       00179900
         BCTR  R6,0                    DECREMENT FOR MOVE               00180000
         EX    R6,MOVEDEST             MOVE PROG TO TU                  00180100
NOPROG   DS    0H                                                       00180200
         CLC   PLINELEN(2),HALF1       SEE IF LL SPECIFIED              00180300
         BNE   LLDEF                   NO...                            00180400
         L     R7,RLINELEN             LOAD POINTER TO LL FIELD         00180500
         LH    R6,RLINELEN+4           LOAD LENGTH OF LL FIELD          00180600
         BCTR  R6,0                    DECREMENT FOR PACK               00180700
         EX    R6,ZEROTEST             LINELENGTH 0 ENTERED?            00180800
         BE    LLDEF                   IF YES, USE DEFAULT              00180900
         EX    R6,PACKLEN              CONVERT INTO PACKED DECIMAL      00181000
         CVB   R6,DEC                  CONVERT INTO FIXED BINARY        00181100
         CH    R6,HALF1                LESS THAN ONE?                   00181200
         BNL   NOLLDEF                 IF YES, USE DEFAULT              00181300
         CH    R6,HALF208              GREATER THAN 208?                00181400
         BNH   NOLLDEF                 IF YES, USE DEFAULT              00181500
LLDEF    LH    R6,HALF132              PLACE 132 IN R6                  00181600
NOLLDEF  STH   R6,LINELEN              STORE INTO LINELEN               00181700
         A     R6,FULL5                ADD LENGTH FOR VB OUTPUT         00181800
         STH   R6,VBLEN                STORE INTO VBLEN1                00181900
         MVI   CCBIT,BLANK             INITIALIZE CCBIT WITH BLANK      00182000
         CLC   PPAGELEN(2),HALF1       SEE IF PL SPECIFIED              00182100
         BNE   PLDEF                   NO...                            00182200
         OI    CCBIT,HIGH              YES, SET BIT FOR PAGE LEN        00182300
         L     R7,RPAGELEN             LOAD POINTER TO PL FIELD         00182400
         LH    R6,RPAGELEN+4           LOAD LENGTH OF PL FIELD          00182500
         BCTR  R6,0                    DECREMENT FOR PACK               00182600
         EX    R6,ZEROTEST             PAGELENGTH 0 SPECIFIED?          00182700
         BE    PLDEF                   IF YES, USE DEFAULT              00182800
         EX    R6,PACKPAG              CONVERT INTO PACKED DECIMAL      00182900
         CVB   R6,DEC                  CONVERT INTO FIXED BINARY        00183000
         CH    R6,HALF5                LESS THAN 5?                     00183100
         BNL   NOPLDEF                 IF YES, USE DEFAULT              00183200
         CH    R6,HALF120              GREATER THAN 120?         ARAMCO 00183300
         BNH   NOPLDEF                 IF YES, USE DEFAULT              00183400
PLDEF    LH    R6,HALF60               LOAD DEFAULT INTO R6      ARAMCO 00183500
NOPLDEF  STH   R6,PAGELEN              STORE INTO PAGELEN               00183600
         CLC   PSPACE(2),HALF1         SEE IF SINGLE SPACE FORMAT       00183700
         BE    SETSS                   YES...                           00183800
         CLC   PSPACE(2),HALF2         SEE IF DOUBLE SPACE FORMAT       00183900
         BE    SETDS                   GO ON                            00184000
         CLC   PASA(2),HALF1           USER SAYS ASA IS IN DATA ?   WFB 00184100
         BNE   CCSET                   NO, CONTINUE                 WFB 00184200
         OI    CCBIT,FORCEASA          YES, SET FORCE BIT           WFB 00184300
         B     CCSET                   CONTINUE IF NEITHER SS OR DS     00184400
SETSS    OI    CCBIT,MID1              FOR SINGLE SPACE CC              00184500
         B     CCSET                                                    00184600
SETDS    OI    CCBIT,MID2              FOR DOUBLE SPACE CC              00184700
         LH    R6,PAGELEN              DECREMENT PAGE LENGTH     ARAMCO 00184800
         BCTR  R6,0                                              ARAMCO 00184900
         STH   R6,PAGELEN              BY 1 FOR DS LISTINGS.     ARAMCO 00185000
CCSET    DS    0H                                                       00185100
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00185200
**************************** END OF GTEL MOD ************************** 00185300
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00185400
*---------------------------------------------------------------------* 00185500
*------------------------- START OF ARAMCO MOD -----------------------* 00185600
*---------------------------------------------------------------------* 00185700
         CLC   PBURST(2),HALF1         WAS BURST PARM "BURST"?          00185800
         BNE   NOBURST                 NO, CHECK FLASH                  00185900
         OI    SETFLAG,SETBURST        YES, TURN ON FLAG                00186000
         OI    SETPRTE+16,X'80'        AND SET SETPRT BIT               00186100
NOBURST  DS    0H                                                       00186200
         CLC   PFLASH(2),HALF1         ANY FLASH PARM ?                 00186300
         BNE   NOFLASH                 NO, CHECK CHARS                  00186400
         L     R7,RFLASH               YES, POINT AT PARM               00186500
         LH    R6,RFLASH+4             AND GET LENGTH                   00186600
         BCTR  R6,0                    DECREMENT FOR MOVE               00186700
         MVC   SETFLASH(4),BLANKS      BLANK IT OUT                     00186800
         MVC   SETFLASH(1),0(R7)                                        00186900
         EX    R6,*-6                  AND MOVE PARM TO SETPRT          00187000
         OI    SETFLAG,SETFLSH                                          00187100
NOFLASH  DS    0H                                                       00187200
         CLC   PCHARS(2),HALF1         ANY CHARS PARM ?                 00187300
         BNE   CHAREND                 NO, END OF ARAMCO                00187400
         OI    SETFLAG,SETCHAR                                          00187500
         CLI   RCHARS+8,X'FF'          MORE THAN ONE CHAR SET?          00187600
         BE    CHARSET                 NO, BRANCH                       00187700
         USING IHADCB,R15                                               00187800
         LA    R15,OUTPUTA                                              00187900
         OI    DCBOPTCD,DCBOPTJ        YES, SET OPTCD=J                 00188000
         LA    R15,OUTPUTM AND ON VBM DCB TOO                           00188100
         OI    DCBOPTCD,DCBOPTJ                                         00188200
         DROP  R15                                                      00188300
CHARSET  LA    R15,4                   SET LOOP LIMIT                   00188400
         LA    R14,RCHARS              POINT AT FIRST CHARS PDE         00188500
         LA    R2,SETCHARS             AND AT SETPRT CHARS PARM         00188600
CHARLOOP L     R7,0(R14)               POINT TO INPUT CHARS PARM        00188700
         LH    R6,4(R14)               AND GET LENGTH                   00188800
         BCTR  R6,0                    DECREMENT FOR MOVE               00188900
         MVC   0(4,R2),BLANKS          BLANK IT OUT                     00189000
         MVC   0(0,R2),0(R7)                                            00189100
         EX    R6,*-6                  AND MOVE PARM TO SETPRT          00189200
         CLI   8(R14),X'FF'            END OF LIST?                     00189300
         BE    CHAREND                 YES, EXIT LOOP                   00189400
         L     R14,8(R14)              NO, BUMP LOOP                    00189500
         LA    R2,4(R2)                POINTERS AND KEEP GOING          00189600
         BCT   R15,CHARLOOP            MAX OF 4 CHARS PARMS             00189700
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00189800
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00189900
         PUTLINE OUTPUT=(CHARMSG,SINGLE,DATA),MF=(E,IOPLSECT)           00190000
         DROP  R15                                                  WFB 00190100
*DELETED B     CHAREND                                              WFB 00190200
*                                      CHARMSG MOVED TO MSG CSECT   WFB 00190300
CHAREND  DS    0H                                                       00190400
*---------------------------------------------------------------------* 00190500
*--------------------------- END OF ARAMCO MOD -----------------------* 00190600
*---------------------------------------------------------------------* 00190700
         LA    R1,4(R1)                LOAD POINTER TO NEXT TEXT UNIT   00190800
*                                      POINTER                          00190900
         LA    R2,TEXTFC               LOAD POINTER TO TEXT UNIT F      00191000
*                                      PERMANENTLY ALLOCATED            00191100
*                                      ATTRIBUTE                        00191200
         ST    R2,S99TUPTR             STORE POINTER IN TUPL            00191300
         MVI   S99TUPTR,S99TUPLN       INDICATE END OF TEXT UNIT        00191400
*                                      POINTER LIST                     00191500
         DROP  R1,R2,R9                DROP ADDRESSABILITY TO DSECTS    00191600
         LA    R1,RBPTR                LOAD ADDRESS OF REQUEST BLOCK    00191700
*                                      POINTER                          00191800
         DYNALLOC                      ISSUE DYNAMIC ALLOCATION SVC     00191900
         LTR   R15,R15                 SEE IF RETURN CODE IS ZERO       00192000
         BNZ   ALCFAIL                 NO.....GO AND CALL DAIR FAIL     00192100
         MVC   OPENLST,OPENCLOS        MOVE OPEN(CLOSE) LIST CONSTANT   00192200
*                                      INTO WORKAREA                    00192300
         OPEN  ((R5),(OUTPUT)),MF=(E,OPENLST)                           00192400
*                                      OPEN OUTPUT DCB                  00192500
         TM    48(R5),DCBOFOPN         SEE IF DCB OPENED SUCCESSFULLY   00192600
         BNO   OPENFAIL                NO.....GO PUT OUT OUTPUT DCB     00192700
*---------------------------------------------------------------------* 00192800
*------------------------- START OF ARAMCO MOD -----------------------* 00192900
*---------------------------------------------------------------------* 00193000
CKSETPRT CLI   SETFLAG,X'00'           NEED SETPRT ?                    00193100
         BE    NOSETPRT                NO, SKIP IT                      00193200
         L     R6,DAPLSECT             ADDRESS UPT                      00193300
         USING UPT,R6                                                   00193400
         MVC   SAVEUPT(1),UPTSWS       SAVE UPT SWITCHES                00193500
         NI    UPTSWS,X'FF'-UPTWTP     GET RID OF MSG IEF288I           00193600
         SETPRT (R5),MF=(E,SETPRTE)                                     00193700
         MVC   UPTSWS(1),SAVEUPT       RESTORE UPT SWITCHES             00193800
         DROP R6                                                        00193900
NOSETPRT DS    0H                                                       00194000
*---------------------------------------------------------------------* 00194100
*--------------------------- END OF ARAMCO MOD -----------------------* 00194200
*---------------------------------------------------------------------* 00194300
*                                      NOT OPENED MESSAGE               00194400
         LM    14,9,ALCSAVE            RESTORE REGISTERS                00194500
         BR    R14                     RETURN TO CALLER                 00194600
ALCFAIL  DS    0H                                                       00194700
         LA    R1,REQBLK               LOAD ADDRESS OF REQUEST          00194800
*                                      BLOCK                            00194900
         MVI   DFID+1,DFSVC99          SET DAIR FAIL FOR SVC 99 ERROR   00195000
         BAL   R2,DAIRFAIL             LOAD ADDRESS OF OPEN FAIL AND    00195100
*                                      BRANCH TO DAIRFAIL ROUTINE       00195200
OPENFAIL DS    0H                                                       00195300
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00195400
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00195500
         PUTLINE OUTPUT=(OPENMSG,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT  00195600
*                                      OUTPUT DCB NOT OPEND MESSAGE     00195700
         DROP  R15                                                  WFB 00195800
         S     R3,FULL4                GET POINTER TO PUTLINE DDNAME    00195900
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00196000
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00196100
         PUTLINE OUTPUT=((R3),SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT     00196200
*                                      DDNAME                           00196300
         DROP  R15                                                  WFB 00196400
         B     CLOSDCBS                GO CLOSE DCBS AND RETURN         00196500
*                                                                       00196600
*********************************************************************** 00196700
*                                                                     * 00196800
*        INVOKE DAIR TO FREE FILENAME VIA CALLTSSR                    * 00196900
*           AND CHECK FOR ZERO RETURN CODE                            * 00197000
*                                                                     * 00197100
*********************************************************************** 00197200
*                                                                       00197300
FREEDD   DS    0H                                                       00197400
         SLR   R8,R8                   INITIALIZE REGISTER 8 TO ZERO    00197500
*                                      RETURN CODE                      00197600
         MVC   DAP18(DAPB18L),DAPB18C  INITIALIZE DAIR PARAMETER BLOCK  00197700
*                                      18 (FREE BY DATASET)             00197800
         LA    R4,DAP18                LOAD ADDRESS OF DAPB             00197900
         USING DAPB18,R4               ESTABLISH ADDRESSABILITY TO      00198000
*                                      DAPB                             00198100
         MVC   DA18DDN,0(R1)           MOVE DDNAME INTO DAPB            00198200
         SLR   R7,R7                   ZERO REGISTER 7                  00198300
         ST    R7,ECB                  STORE REGISTER 7 AS DUMMY ECB    00198400
         LA    R1,DAPLSECT             LOAD ADDRESS OF DAPL             00198500
         USING DAPL,R1                 ESTABLISH ADDRESSABILITY TO DAPL 00198600
         ST    R4,DAPLDAPB             STORE ADDRESS OF DAPB IN DAPL    00198700
         DROP  R1,R4                   DROP ADDRESSABILITY TO DAPL AND  00198800
*                                      DAPB                             00198900
         CALLTSSR EP=IKJDAIR           CALL DAIR TO FREE DDNAME         00199000
         C     R15,FULL28              SEE IF RETURN CODE IS 28         00199100
*                                      (DDNAME NOT ALLOCATED)           00199200
         BER   R2                      YES....GO CONTINUE PROCESSING    00199300
         LTR   R15,R15                 SEE IF RETURN CODE IS ZERO       00199400
         BZR   R2                      YES....GO CONTINUE PROCESSING    00199500
         MVI   DFID+1,DFDAIR           SET DAIRFAIL ID TO INDICATE DAIR 00199600
*                                                                       00199700
*********************************************************************** 00199800
*                                                                     * 00199900
*        INVOKE DAIRFAIL TO DISPLAY AN ERROR MESSAGE                  * 00200000
*                                                                     * 00200100
*********************************************************************** 00200200
*                                                                       00200300
DAIRFAIL XC    DFPARMS(DFLEN),DFPARMS  INITIALIZE PARMLIST FOR DAIR     00200400
*                                      FAIL TO ZEROS                    00200500
         ST    R1,DFDAPLP              STORE POINTER TO DAPL/RB IN      00200600
*                                      PARAMETER LIST                   00200700
         ST    R15,RETCODE             STORE RETURN CODE                00200800
         LA    R1,RETCODE              LOAD ADDRESS OF RETURN CODE      00200900
         ST    R1,DFRCP                STORE POINTER TO RETURN CODE IN  00201000
*                                      PARAMETER LIST                   00201100
         LA    R1,FULL0                LOAD ADDRESS OF FULLWORD OF      00201200
*                                      ZEROS                            00201300
         ST    R1,DFJEFF02             STORE DUMMY POINTER TO IKJEFF02  00201400
*                                      IN PARMLIST                      00201500
         LA    R1,DFID                 LOAD ADDRESS OF DAIR FAIL ID     00201600
*                                      FIELD                            00201700
         ST    R1,DFIDP                STORE POINTER TO DFID IN         00201800
*                                      PARMLIST                         00201900
         MVI   DFID,NOWTP              SET FOR NO WRITE TO PROGRAMMER   00202000
         L     R1,SAVEAREA+4           LOAD ADDRESS OF PEVIOUS          00202100
*                                      SAVEAREA                         00202200
         L     R1,24(R1)               LOAD POINTER TO CPPL             00202300
         ST    R1,DFCPPLP              STORE POINTER TO CPPL IN         00202400
*                                      PARMLIST                         00202500
         LINK  EP=IKJEFF18,MF=(E,DFPARMS)  LINK TO DAIR FAIL SERVICE    00202600
*                                      ROUTINE TO HANDLE RETURN         00202700
*                                      CODE                             00202800
         LTR   R15,R15                 SEE IF RETURN CODE IS ZERO       00202900
         BZR   R2                      YES....GO RETURN TO CALLER       00203000
         LR    R8,R15                  LOAD REGISTER 8 WITH RETURN CODE 00203100
         BAL   R14,SETCODE             GO CONVERT CODE TO DECIMAL       00203200
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00203300
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00203400
         PUTLINE OUTPUT=(DRFLERR,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT  00203500
*                                      DAIR FAIL ERROR MESSAGE          00203600
         L     R15,MSGCSECT            GET ADDRESS OF MESSAGE CSECT WFB 00203700
         USING MESSAGES,R15            ESTABLISH ADDRESSABILITY     WFB 00203800
         PUTLINE OUTPUT=(RETNCD,SINGLE,DATA),MF=(E,IOPLSECT)  PUT OUT   00203900
*                                      DECIMAL RETURN CODE              00204000
         DROP  R15                                                  WFB 00204100
         BR    R2                      GO RETURN TO CALLER              00204200
*                                                                       00204300
******************** INSTRUCTIONS TO BE EXECUTED ********************** 00204400
*                                                                       00204500
FOLDLINE OC    5(0,R9),BLANKS                                      GTEL 00204600
MOVEDSN  MVC   DSNBUF(0),0(R5)                                          00204700
MOVEVOL  MVC   VOLUME(0),0(R7)                                          00204800
MOVEUNIT MVC   UNIT(0),0(R7)                                        WFB 00204900
PACKLEN  PACK  DEC(8),0(0,R7)                                      GTEL 00205000
PACKPAG  PACK  DEC(8),0(0,R7)                                      GTEL 00205100
PACKCOPY PACK  DEC(8),0(0,R7)                                           00205200
ZEROTEST CLC   0(0,R7),ZEROS                                            00205300
         USING S99TUNIT,R2             ADDRESSABILITY TO S99 TEXT   WFB 00205400
MOVEDDN  MVC   S99TUPAR(0),0(R5)       MOVE DDNAME INTO S99 TEXT    WFB 00205500
         DROP  R2                                                   WFB 00205600
         USING LINDSECT,R15            ADDRESSABILITY TO OUTPUT REC WFB 00205700
MOVEUDK  MVC   RECDATA+3(0),0(R14)     MOVE UDK FONT NAME TO OUTPUT WFB 00205800
         DROP  R15                                                  WFB 00205900
         USING DAPB08,R8                                                00206000
MOVEMEM  MVC   DA08MNM(0),0(R5)                                         00206100
MOVEPASS MVC   DA08PSWD(0),0(R5)                                        00206200
         DROP  R8                                                       00206300
DFPBMVE  MVC   DFPBNAME(0),0(R5)                                   GTEL 00206400
*                                                                       00206500
***************************** CONSTANTS ******************************* 00206600
*                                                                       00206700
******************** DAIR CONTROL BLOCK CONSTANTS ********************* 00206800
DAPB08C  DS    0F                                                       00206900
         DC    X'0008'                 DA08CD                           00207000
         DC    H'0'                    DA08FLG                          00207100
         DC    H'0'                    DA08DARC                         00207200
         DC    H'0'                    DA08CTRC                         00207300
         DC    A(0)                    DA08PDSN                         00207400
         DC    CL8'PRINTI  '           DA08DDN                          00207500
         DC    CL8' '                  DA08UNIT                         00207600
         DC    CL8' '                  DA08SER                          00207700
         DC    F'0'                    DA08BLK                          00207800
         DC    F'0'                    DA08PQTY                         00207900
         DC    F'0'                    DA08SQTY                         00208000
         DC    F'0'                    DA08DQTY                         00208100
         DC    CL8' '                  DA08MNM                          00208200
         DC    CL8' '                  DA08PSWD                         00208300
         DC    X'08'                   DA08DSP1      SHR                00208400
         DC    X'08'                   DA08DSP2      KEEP               00208500
         DC    X'08'                   DA08DSP3      KEEP               00208600
         DC    X'08'                   DA08CTL       PERM               00208700
         DC    F'0'                    DA08DSO                          00208800
         DC    CL8' '                  DA08ALN                          00208900
DAPB08L  EQU   *-DAPB08C               LENGTH                           00209000
         SPACE 2                                                        00209100
DAPB18C  DS    0F                                                       00209200
         DC    X'0018'                 DA18CD                           00209300
         DC    X'0000'                 DA18FLG                          00209400
         DC    H'0'                    DA18DARC                         00209500
         DC    H'0'                    DA18CTRC                         00209600
         DC    F'0'                    DA18PDSN                         00209700
         DC    CL8'PRINTI'             DA18DDN                          00209800
         DC    CL8' '                  DA18MNM                          00209900
         DC    CL2' '                  DA18SCLS                         00210000
         DC    X'08'                   DA18DPS2                         00210100
         DC    X'10'                   DA18CTL                          00210200
         DC    CL8' '                  DA18JBNM                         00210300
DAPB18L  EQU   *-DAPB18C               LENGTH                           00210400
         SPACE 2                                                        00210500
INPUTC   DCB   DSORG=PS,MACRF=(GM),EODAD=EXITI,SYNAD=ERRI,DDNAME=PRINTI 00210600
INPUTL   EQU   *-INPUTC                                                 00210700
*                                                                       00210800
OUTPUTAC DCB   DSORG=PS,MACRF=(PM),SYNAD=ERRO,DDNAME=PRINTA,RECFM=VBA, X00210900
               LRECL=256,BLKSIZE=3120                                   00211000
OUTPUTAL EQU   *-OUTPUTAC                                               00211100
*                                                                       00211200
OUTPUTMC DCB   DSORG=PS,MACRF=(PM),SYNAD=ERRO,DDNAME=PRINTM,RECFM=VBM, X00211300
               LRECL=256,BLKSIZE=3120                                   00211400
OUTPUTML EQU   *-OUTPUTMC                                               00211500
*                                                                       00211600
DIRECTC  DCB   DDNAME=PRINTI,DSORG=PS,MACRF=(GM),RECFM=U,BLKSIZE=256,  X00211700
               SYNAD=SERRI,EODAD=FREEBLK                                00211800
DIRECTL  EQU   *-DIRECTC                                                00211900
*                                                                       00212000
OPENCLOS OPEN  (,),MF=L                                                 00212100
         SPACE 2                                                        00212200
*---------------------------------------------------------------------* 00212300
*------------------------- START OF ARAMCO MOD -----------------------* 00212400
*---------------------------------------------------------------------* 00212500
SETPRTL  SETPRT OUTPUTAC,,MF=L                                          00212600
*---------------------------------------------------------------------* 00212700
*--------------------------- END OF ARAMCO MOD -----------------------* 00212800
*---------------------------------------------------------------------* 00212900
HEADERC  DS    0F                                                       00213000
         DC    H'75'                   (WAS 49 BEFORE DATE)  ARAMCO WFB 00213100
         DC    H'0'                                                     00213200
HDRCNTLC DC    C' '                                                     00213300
         DC    CL34' **** TSO FOREGROUND HARDCOPY ****'      ARAMCO WFB 00213400
         DC    CL36'      HH:MM:SS    MONTHNAME DY, YEAR'           WFB 00213500
HEADERM  DS    0F                                                       00213600
         DC    H'49'                                             ARAMCO 00213700
         DC    H'0'                                                     00213800
         DC    C' '                                                     00213900
         DC    CL44' *** TSO FOREGROUND MEMBER LIST ***'         ARAMCO 00214000
         DS    0H                                                ARAMCO 00214100
LDSNAME  DS    0CL12                                                    00214200
         ORG   LDSNAME                                                  00214300
         DC    H'86'                                             ARAMCO 00214400
         DC    H'0'                                                     00214500
         DC    CL9'  DSNAME='                                    ARAMCO 00214600
VOLCONST DC    CL11'   VOLUME: '       FOR HEADING WHEN VOL(...)    WFB 00214700
DDNCONST DC    CL11'   DDNAME: '       FOR HEADING WHEN DDN(...)    WFB 00214800
EJECTM   DS    0F                                                       00214900
         DC    H'5'                                                     00215000
         DC    H'0'                                                     00215100
         DC    X'8B'                                                    00215200
EJECTA   DS    0F                                                       00215300
         DC    H'5'                                                     00215400
         DC    H'0'                                                     00215500
         DC    C'1'                                                     00215600
SPACE    EQU   EJECTA                                                   00215700
         SPACE 2                                                        00215800
FULL0    DC    F'0'                                                     00215900
FULL1    DC    F'1'                                                     00216000
FULL4    DC    F'4'                                                     00216100
FULL5    DC    F'5'                                                     00216200
FULL20   DC    F'20'                                                    00216300
FULL28   DC    F'28'                                                    00216400
FULL61   DC    F'61'                                               GTEL 00216500
FULL132  DC    F'132'                                              GTEL 00216600
FULL256  DC    F'256'                                                   00216700
PRINTILN DC    H'12',H'0'                                               00216800
PRINTI   DC    CL8'PRINTI'                                              00216900
PRINTALN DC    H'12',H'0'                                               00217000
PRINTA   DC    CL8'PRINTA'                                              00217100
PRINTMLN DC    H'12',H'0'                                               00217200
PRINTM   DC    CL8'PRINTM'                                              00217300
BLANKS   DC    256CL1' '                                                00217400
ZEROS    DC    4CL1'0'                                                  00217500
ALIAS    DC    CL8' *ALIAS*'                                            00217600
ENDCHAIN DS    0F                                                       00217700
         DC    X'FF000000'                                              00217800
MEMDATL  DC    X'00'                   SUBPOOL NUMBER                   00217900
         DC    AL3(1808)                                                00218000
HALF0    DC    H'0'                                                     00218100
HALF1    DC    H'1'                                                     00218200
HALF2    DC    H'2'                                                     00218300
HALF4    DC    H'4'                                              ARAMCO 00218400
HALF5    DC    H'5'                                                     00218500
HALF6    DC    H'6'                                                     00218600
HALF12   DC    H'12'                                                    00218700
HALF85   DC    H'85'                                                    00218800
HALF256  DC    H'256'                                                   00218900
HALF132  DC    H'132'                                              GTEL 00219000
HALF208  DC    H'208'                                            ARAMCO 00219100
HALF60   DC    H'60'                                             ARAMCO 00219200
HALF120  DC    H'120'                                            ARAMCO 00219300
PATCH    DC    C'PATCH AREA',20S(*)                                 WFB 00219400
MSGCSECT DC    A(MESSAGES)             ADDRESS OF MESSAGE CSECT     WFB 00219500
UDKRESET DC    H'14',H'0',CL10' =UDK={{+X'  DEFINE UDK THEN RESET   WFB 00219600
UDKSET   DC    H'11',H'0',CL7' =UDK={'      DEFINE UDK              WFB 00219700
UDKFHEAD DC    H'0',H'0',CL4' {+2'          SET FONT NAME #2        WFB 00219800
UDKFSEL  DC    H'7',H'0',CL3' {2'           SELECT FONT #2          WFB 00219900
NOMSG    EQU   X'04'                   FLAG IN BYTE VOLBIT          WFB 00220000
UDKDONE  EQU   X'02'                   FLAG IN BYTE VOLBIT          WFB 00220100
FORCEASA EQU   X'04'                   FLAG IN BYTE CCBIT           WFB 00220200
HEXFF    EQU   X'FF'                                                    00220300
HIGH     EQU   X'80'                                                    00220400
LOW      EQU   X'01'                                                    00220500
MID1     EQU   X'10'                                               GTEL 00220600
MID2     EQU   X'08'                                               GTEL 00220700
JFCPDS   EQU   X'01'                                                    00220800
BLANK    EQU   X'40'                                                    00220900
HEX00    EQU   X'00'                                                    00221000
HEXF0    EQU   X'F0'                                                    00221100
HEXF1    EQU   X'F1'                                                    00221200
SCLSA    EQU   C'A'                                                     00221300
SKIPM    EQU   X'09'                                                    00221400
DSOPS    EQU   X'40'                                                    00221500
DSOPO    EQU   X'02'                                                    00221600
NOWTP    EQU   X'00'                                                    00221700
         SPACE 2                                                        00221800
****************** POINTER TO PARS PARAMETER CSECT ******************** 00221900
PCLADDR  DC    A(PARMTAB)                                               00222000
         SPACE 2                                                        00222100
************************ PARS PARAMETER LIST ************************** 00222200
PARMTAB  IKJPARM  DSECT=IKJPARMD                                        00222300
DSNAMES  IKJPOSIT  DSTHING,LIST,USID,                                  X00222400
               PROMPT='DSNAME, (LIST OF DSNAMES), OR * IF DDNAME(...) IX00222500
               S SPECIFIED',                                        WFBX00222600
               HELP=('THE NAME OF THE DATASET TO BE PRINTED, OR AN ASTEX00222700
               RISK IF A PREALLOCATED DDNAME IS TO BE USED.')       WFB 00222800
PCLASS   IKJKEYWD                                                       00222900
         IKJNAME 'CLASS',SUBFLD=CLASSUB                                 00223000
PDEST    IKJKEYWD                                                       00223100
         IKJNAME 'DEST',SUBFLD=DESTSUB                                  00223200
PHOLD    IKJKEYWD                                                       00223300
         IKJNAME 'HOLD'                                                 00223400
         IKJNAME 'NOHOLD'                                               00223500
PCOPIES  IKJKEYWD                                                       00223600
         IKJNAME 'COPIES',SUBFLD=COPYSUB                                00223700
PPRINT   IKJKEYWD                                                       00223800
         IKJNAME 'PRINT'                                                00223900
         IKJNAME 'NOPRINT'                                              00224000
PLIST    IKJKEYWD                                                       00224100
         IKJNAME 'LIST'                                                 00224200
         IKJNAME 'NOLIST'                                               00224300
PHEAD    IKJKEYWD                                                       00224400
         IKJNAME 'NOHEADING'                                       GTEL 00224500
         IKJNAME 'HEADING'                                         GTEL 00224600
PVOL     IKJKEYWD                                                       00224700
         IKJNAME 'VOLUME',SUBFLD=VOLSUB                                 00224800
PFOLD    IKJKEYWD                                                       00224900
         IKJNAME 'FOLD',ALIAS=('CAPS')                                  00225000
         IKJNAME 'NOFOLD',ALIAS=('ASIS')                                00225100
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00225200
**************************** START OF GTEL MOD ************************ 00225300
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00225400
PSPACE   IKJKEYWD                                                       00225500
         IKJNAME 'SINGLESPACE',ALIAS=('SS','NOCC')                  WFB 00225600
         IKJNAME 'DOUBLESPACE',ALIAS=('DS')                         WFB 00225700
PFORMS   IKJKEYWD                                                       00225800
         IKJNAME  'FORMS',SUBFLD=SFORMS                                 00225900
PTRAIN   IKJKEYWD                                                       00226000
         IKJNAME  'TRAIN',SUBFLD=STRAIN,ALIAS=('UCS')                   00226100
PFCB     IKJKEYWD                                                       00226200
         IKJNAME    'FCB',SUBFLD=SFCB                                   00226300
PPROG    IKJKEYWD                                                       00226400
         IKJNAME    'PROG',SUBFLD=SPROG                                 00226500
PTEXT    IKJKEYWD                                                       00226600
         IKJNAME    'TEXT',INSERT='UCS(TN) ASIS'                        00226700
PLINELEN IKJKEYWD                                                       00226800
         IKJNAME 'LINELENGTH',SUBFLD=SLINELEN,ALIAS=('LL')              00226900
PPAGELEN IKJKEYWD                                                       00227000
         IKJNAME 'PAGELENGTH',SUBFLD=SPAGELEN,ALIAS=('PL')              00227100
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00227200
**************************** END OF GTEL MOD ************************** 00227300
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00227400
*---------------------------------------------------------------------* 00227500
*------------------------- START OF ARAMCO MOD -----------------------* 00227600
*---------------------------------------------------------------------* 00227700
PBURST   IKJKEYWD                                                       00227800
         IKJNAME  'BURST'                                               00227900
         IKJNAME  'NOBURST'                                             00228000
PFLASH   IKJKEYWD                                                       00228100
         IKJNAME  'FLASH',SUBFLD=SFLASH                                 00228200
PCHARS   IKJKEYWD                                                       00228300
         IKJNAME  'CHARS',SUBFLD=SCHARS                                 00228400
*---------------------------------------------------------------------* 00228500
*--------------------------- END OF ARAMCO MOD -----------------------* 00228600
*---------------------------------------------------------------------* 00228700
PUNIT    IKJKEYWD ,                                                 WFB 00228800
         IKJNAME 'UNIT',SUBFLD=UNITSUB                              WFB 00228900
PNOMSG   IKJKEYWD ,                                                 WFB 00229000
         IKJNAME 'NOMSGS',ALIAS=('NOMESSAGES')                      WFB 00229100
PDDNAME  IKJKEYWD ,                                                 WFB 00229200
         IKJNAME 'DDNAME',ALIAS=('FILE'),SUBFLD=DDNSUB              WFB 00229300
PASA     IKJKEYWD ,                                                 WFB 00229400
         IKJNAME 'ASA'                                              WFB 00229500
PUDKFONT IKJKEYWD ,                                                 WFB 00229600
         IKJNAME 'UDKFONT',SUBFLD=UDKSUB                            WFB 00229700
*                                                                       00229800
*        B E G I N   S U B F I E L D S                                  00229900
CLASSUB  IKJSUBF                                                        00230000
SCLASS   IKJIDENT 'CLASSNAME',LIST,FIRST=NONATNUM,MAXLNTH=1,           X00230100
               PROMPT='CLASS NAME'                                      00230200
DESTSUB  IKJSUBF                                                        00230300
SDEST    IKJIDENT 'DESTINATION',MAXLNTH=17,                         WFBX00230400
               FIRST=ALPHANUM,OTHER=ANY,VALIDCK=VALDEST,            WFBX00230500
               PROMPT='DESTINATION FOR OUTPUT',                     WFBX00230600
               HELP=('WHERE TO PRINT OUTPUT. DESTINATION CAN BE: REMOTEX00230700
                LINE NUMBER, JES PRINTER NAME, OR NETWORK NODE AND USERX00230800
               ID')                                                 WFB 00230900
COPYSUB  IKJSUBF                                                        00231000
SCOPIES  IKJIDENT 'COPIES',MAXLNTH=3,                                  X00231100
               FIRST=NUMERIC,OTHER=NUMERIC,                            X00231200
               PROMPT='1-3 DIGITS - NUMBER OF COPIES OF OUTPUT',       X00231300
               HELP=('NUMBER OF COPIES OF PRINTOUT DESIRED')            00231400
VOLSUB   IKJSUBF                                                        00231500
SVOL     IKJIDENT 'VOLUME',MAXLNTH=8,                                  X00231600
               FIRST=ALPHANUM,OTHER=ALPHANUM,                          X00231700
               PROMPT='VOLUME SERIAL FOR DATA SETS TO BE PRINTED',     X00231800
               HELP=('VOLUME SERIAL TO BE USED FOR ALL DATA SETS')      00231900
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00232000
**************************** START OF GTEL MOD ************************ 00232100
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00232200
SFORMS   IKJSUBF                                                        00232300
RFORMS   IKJIDENT 'FORMS',MAXLNTH=4,FIRST=ALPHANUM,                    X00232400
               OTHER=ALPHANUM,                                         X00232500
               DEFAULT='$TST',                                      WFBX00232600
               HELP=('AN ALPANUMERIC STRING TO SPECIFY THE FORM')       00232700
STRAIN   IKJSUBF                                                        00232800
RTRAIN   IKJIDENT   'UCS',MAXLNTH=4,FIRST=ALPHANUM,                    X00232900
               OTHER=ALPHANUM,                                         X00233000
               PROMPT='UCS   DESIGNATION FOR PRINTED OUTPUT',          X00233100
               HELP=('AN ALPANUMERIC STRING TO SPECIFY THE TRAIN')      00233200
SFCB     IKJSUBF                                                        00233300
RFCB     IKJIDENT 'FCB',MAXLNTH=4,FIRST=ALPHANUM,                      X00233400
               OTHER=ALPHANUM,                                         X00233500
               PROMPT='FCB DESIGNATION FOR PRINTED OUTPUT',            X00233600
               HELP=('AN ALPANUMERIC STRING TO SPECIFY THE FCB')        00233700
SPROG    IKJSUBF                                                        00233800
RPROG    IKJIDENT 'PROG',MAXLNTH=8,FIRST=ALPHA,                        X00233900
               OTHER=ALPHANUM,                                         X00234000
               PROMPT='PROG DESIGNATION FOR PRINTED OUTPUT',           X00234100
               HELP=('AN ALPANUMERIC STRING TO SPECIFY THE PROG')       00234200
SLINELEN IKJSUBF                                                        00234300
RLINELEN IKJIDENT 'LINELENGTH',MAXLNTH=3,FIRST=NUMERIC,                X00234400
               OTHER=NUMERIC,                                          X00234500
               PROMPT='LINESIZE, DEFAULT=132',                         X00234600
               HELP=('A LENGTH UP TO 208 FOR MAXIMUM PRINT WIDTH')      00234700
SPAGELEN IKJSUBF                                                        00234800
RPAGELEN IKJIDENT 'PAGELENGTH',MAXLNTH=3,FIRST=NUMERIC,                X00234900
               OTHER=NUMERIC,                                          X00235000
               PROMPT='PAGELENGTH, DEFAULT=60',                        X00235100
               HELP=('A LENGTH UP TO 120 FOR PRINTER PAGE LENGTH')      00235200
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00235300
**************************** END OF GTEL MOD ************************** 00235400
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00235500
*---------------------------------------------------------------------* 00235600
*------------------------- START OF ARAMCO MOD -----------------------* 00235700
*---------------------------------------------------------------------* 00235800
SFLASH   IKJSUBF                                                        00235900
RFLASH   IKJIDENT 'FLASH',MAXLNTH=4,FIRST=ALPHANUM,                    X00236000
               OTHER=ALPHANUM,                                         X00236100
               PROMPT='FLASH DESIGNATION FOR PRINTED OUTPUT',          X00236200
               HELP=('FORMS OVERLAY FLASH NAME -- VALID FOR 3800 ONLY') 00236300
SCHARS   IKJSUBF                                                        00236400
RCHARS   IKJIDENT 'CHARS',LIST,MAXLNTH=4,FIRST=ALPHA,                  X00236500
               OTHER=ANY,                                              X00236600
               PROMPT='CHARS DESIGNATION FOR PRINTED OUTPUT',          X00236700
               HELP=('A LIST OF 1 TO 4 CHARACTER SET NAMES -- VALID FORX00236800
                3800 ONLY')                                             00236900
*---------------------------------------------------------------------* 00237000
*--------------------------- END OF ARAMCO MOD -----------------------* 00237100
*---------------------------------------------------------------------* 00237200
UNITSUB  IKJSUBF ,                                                  WFB 00237300
SUNIT    IKJIDENT 'UNIT',MAXLNTH=8,                                 WFBX00237400
               FIRST=ALPHANUM,OTHER=ALPHANUM,                       WFBX00237500
               PROMPT='UNIT TYPE OF SPECIFIED VOLUME',              WFBX00237600
               HELP=('UNIT TYPE WHICH IS REQUIRED IF THE SPECIFIED VOLUX00237700
               ME IS NOT ACCESSIBLE THROUGH YOUR DEFAULT TSO UNIT VALUEX00237800
               ')                                                   WFB 00237900
DDNSUB   IKJSUBF ,                                                  WFB 00238000
SDDNAME  IKJIDENT 'DDNAME',MAXLNTH=8,                               WFBX00238100
               FIRST=ALPHA,OTHER=ALPHANUM,                          WFBX00238200
               PROMPT='DD NAME OF PREVIOUSLY ALLOCATED DATASET',    WFBX00238300
               HELP=('A FILE THAT WAS ALLOCATED EARLIER IN YOUR TSO SESX00238400
               SION','DDNAME IS IGNORED IF THE LAST OR ONLY DSNAME IS NX00238500
               OT AN ASTERISK')                                     WFB 00238600
UDKSUB   IKJSUBF ,                                                  WFB 00238700
SUDKFONT IKJIDENT 'UDK FONT NAME',ASIS,MAXLNTH=20,                  WFBX00238800
               FIRST=ALPHANUM,OTHER=ANY,                            WFBX00238900
               PROMPT='UDK FONT NAME',                              WFBX00239000
               HELP=('A FONT NAME FOR PRINTING ON A XEROX 2700 OR 3700'X00239100
               ,'THE NAME MUST BE ENTERED EXACTLY IN UPPER/LOWER CASE AX00239200
               S THE PRINTER EXPECTS IT')                           WFB 00239300
         IKJENDP                                                        00239400
         SPACE 2                                                        00239500
MESSAGES CSECT ,                                                    WFB 00239600
****************************** MESSAGES ******************************* 00239700
GNRLERR  DC    AL2(GNRLERRL),AL2(0)                                     00239800
         DC    C'AN ERROR WAS ENCOUNTERED IN THE GENERAL FAIL SERVICE RX00239900
               OUTINE.  THE RETURN CODE FROM GNRLFAIL IS: '             00240000
GNRLERRL EQU   *-GNRLERR                                                00240100
*                                                                       00240200
DRFLERR  DC    AL2(DRFLERRL),AL2(0)                                     00240300
         DC    C'AN ERROR WAS ENCOUNTERED IN THE DAIR FAIL SERVICE ROUTX00240400
               INE.  THE RETURN CODE FROM DAIR FAIL IS: '               00240500
DRFLERRL EQU   *-DRFLERR                                                00240600
*                                                                       00240700
OPENMSG  DC    AL2(OPENMSGL),AL2(0)                                     00240800
         DC    C'OUPUT PROCESSING IS BEING TERMINATED.  AN ERROR WAS ENX00240900
               COUNTERED ATTEMPTING TO OPEN THE OUTPUT DATASET ASSOCIATX00241000
               ED WITH DDNAME: '                                        00241100
OPENMSGL EQU   *-OPENMSG                                                00241200
*                                                                       00241300
DSNNOTP  DC    AL2(DSNNOTPL),AL2(0)                                     00241400
         DC    C'AN ERROR OCCURRED AND YOUR DATASET WAS NOT PRINTED'    00241500
DSNNOTPL EQU   *-DSNNOTP                                                00241600
*                                                                       00241700
DSNMSG   DC    AL2(DSNMSGL),AL2(0)                                      00241800
         DC    C'PROCESSING HAS BEEN COMPLETED FOR DATASET: '           00241900
DSNMSGL  EQU   *-DSNMSG                                                 00242000
*                                                                       00242100
MEMMSG   DC    AL2(MEMMSGL),AL2(0)                                      00242200
         DC    C' MEMBER: '                                             00242300
MEMMSGL  EQU   *-MEMMSG                                                 00242400
*                                                                       00242500
PRTMSG   DC    AL2(PRTMSGL),AL2(0)                                      00242600
         DC    C'MEMBERS WILL NOW BE PRINTED FOR DATASET: '             00242700
PRTMSGL  EQU   *-PRTMSG                                                 00242800
*                                                                       00242900
NOTPSPO  DC    AL2(NOTPSPOL),AL2(0)                                     00243000
         DC    C'DATASET IS NOT SEQUENTIAL OR PARTITIONED AND WAS NOT PX00243100
               RINTED.'                                                 00243200
NOTPSPOL EQU   *-NOTPSPO                                                00243300
*                                                                       00243400
SYNADI   DC    AL2(SYNADIL),AL2(0)                                      00243500
         DC    C'A SYNAD ERROR OCURRED READING YOU INPUT DATASET AND ONX00243600
               LY PART OF YOUR DATASET MAY HAVE BEEN PRINTED.'          00243700
SYNADIL  EQU   *-SYNADI                                                 00243800
*                                                                       00243900
SYNADO   DC    AL2(SYNADOL),AL2(0)                                      00244000
         DC    C'A SYNAD ERROR OCURRED WRITING THE OUTPUT DATASET AND NX00244100
               O MORE DATASETS WILL BE PRINTED.'                        00244200
SYNADOL  EQU   *-SYNADO                                                 00244300
*                                                                       00244400
*DSNISU  DC    AL2(DSNISUL),AL2(0)                                      00244500
*        DC    C'DATASET HAS UNDEFINED RECORD LENGTH AND WILL NOT BE PRX00244600
               INTED.'                                                  00244700
*DSNISUL EQU   *-DSNISU                                                 00244800
*                                                                       00244900
*DSNISL  DC    AL2(DSNISLL),AL2(0)                                      00245000
*        DC    C'DATASET HAS RECORD LENGTH GREATER THAN 256.'           00245100
*DSNISLL EQU   *-DSNISL                                                 00245200
*                                                                ARAMCO 00245300
CHARMSG  DC    AL2(CHARMSGL),AL2(0)                              ARAMCO 00245400
         DC    C'MAX OF 4 CHAR SETS ALLOWED, REMAINDER IGNORED'  ARAMCO 00245500
CHARMSGL EQU   *-CHARMSG                                         ARAMCO 00245600
*                                                                   WFB 00245700
NODSNDD  DC    AL2(NODSNDDL),AL2(0)                                 WFB 00245800
         DC    C'NO INPUT SPECIFIED: AN ASTERISK DSNAME IMPLIES A DDNAMX00245900
               E WILL BE USED FOR INPUT, BUT NO DDNAME WAS GIVEN.'  WFB 00246000
NODSNDDL EQU   *-NODSNDD                                            WFB 00246100
NOTLAST  DC    AL2(NOTLASTL),AL2(0)                                 WFB 00246200
         DC    C'AN ASTERISK DSNAME MUST BE THE LAST OR ONLY DSNAME SPEX00246300
               CIFIED FOR DDNAME TO BE PROCESSED.'                  WFB 00246400
NOTLASTL EQU   *-NOTLAST                                            WFB 00246500
         SPACE 2                                                        00246600
************************ DSECTS (MAPPING MACROS) ********************** 00246700
MEMDSECT DSECT                                                          00246800
MEMNTTR  DS    CL11                                                     00246900
         ORG   MEMNTTR                                                  00247000
MEMBER   DS    CL8                                                      00247100
MEMTTR   DS    CL3                                                      00247200
CFIELD   DS    CL1                                                      00247300
MEMSECTN EQU   *                                                        00247400
         IKJDAP08                                                       00247500
DAP08LEN EQU   *-DAPB08                                                 00247600
         IKJDAP18                                                       00247700
DAP18LEN EQU   *-DAPB18                                                 00247800
         IKJDAPL                                                        00247900
DAPLLEN  EQU   *-DAPL                                                   00248000
         IKJCPPL                                                        00248100
CPPLLEN  EQU   *-CPPL                                                   00248200
         IKJPPL                                                         00248300
PPLLEN   EQU   *-PPL                                                    00248400
         IKJIOPL                                                        00248500
IOPLLEN  EQU   *-IOPL                                                   00248600
         IHADSAB                                                        00248700
TIOEDDNM EQU   4           X'1C'(OFFSET) - X'18'(JOB STEP)              00248800
         CVT   DSECT=YES                                            WFB 00248900
         IEFZB4D0                                                       00249000
         IEFZB4D2                                                       00249100
         IKJDFPL                                                   GTEL 00249200
         IKJDFPB                                                   GTEL 00249300
         IKJUPT                                                  ARAMCO 00249400
RBLEN    EQU   S99RBEND-S99RB                                           00249500
         PRINT NOGEN                                                    00249600
         DCBD  DSORG=(PS,PO)                                            00249700
         PRINT GEN                                                      00249800
         EJECT                                                          00249900
DALUSRID EQU   X'0063'                                              JLM 00250000
******************** CONSTANTS FOR DYNAMIC ALLOCATION ***************** 00250100
PRINTOFF CSECT                                                          00250200
REQBLKC  DC    AL1(S99RBEND-S99RB),AL1(S99VRBAL),18AL1(0)               00250300
TEXTAC   DC    AL2(DALDDNAM),AL2(1),AL2(8),CL8'PRINT'  DDNAME           00250400
TEXTALEN EQU   *-TEXTAC                                                 00250500
TEXTBC   DC    AL2(DALSYSOU),AL2(1),AL2(1),C'A'        SYSOUT CLASS     00250600
TEXTBLEN EQU   *-TEXTBC                                                 00250700
TEXTCC   DC    AL2(DALSUSER),AL2(1),AL2(8),CL8'LOCAL'  DESTINATION      00250800
TEXTCLEN EQU   *-TEXTCC                                                 00250900
TEXTDC   DC    AL2(DALSHOLD),AL2(0)                    SYSOUT HOLD      00251000
TEXTDLEN EQU   *-TEXTDC                                                 00251100
TEXTEC   DC    AL2(DALCOPYS),AL2(1),AL2(1),AL2(1)      SYSOUT COPIES    00251200
TEXTELEN EQU   *-TEXTEC                                                 00251300
TEXTFC   DC    AL2(DALPERMA),AL2(0)              PERM ALLOCATION        00251400
TEXTFLEN EQU   *-TEXTFC                                                 00251500
TEXTGC   DC    AL2(DALFCBIM),AL2(1),AL2(4),CL4'STD.'  FCB          GTEL 00251600
TEXTGLEN EQU   *-TEXTGC                                        GTEL WFB 00251700
TEXTHC   DC    AL2(DALUCS),AL2(1),AL2(2),CL4'PN'      UCS          GTEL 00251800
TEXTHLEN EQU   *-TEXTHC                                        GTEL WFB 00251900
TEXTIC   DC    AL2(DALSFMNO),AL2(1),AL2(2),CL4'STD.'  FORMS        GTEL 00252000
TEXTILEN EQU   *-TEXTIC                                        GTEL WFB 00252100
TEXTJC   DC    AL2(DALSPGNM),AL2(1),AL2(8),CL8'PROG'  PROG         GTEL 00252200
TEXTJLEN EQU   *-TEXTJC                                        GTEL WFB 00252300
TEXTKC   DC    AL2(DALUSRID),AL2(1),AL2(8),CL8'USER'  USERID        WFB 00252400
TEXTKLEN EQU   *-TEXTKC                                             WFB 00252500
TEXTLC   DC    AL2(DINDDNAM),AL2(1),AL2(8),CL8' '   PREALLOC DDNAME WFB 00252600
TEXTLLEN EQU   *-TEXTLC                                             WFB 00252700
TEXTMC   DC    AL2(DINRTDSN),AL2(1),AL2(44),CL44' ' RETURNED DSNAME WFB 00252800
TEXTMLEN EQU   *-TEXTMC                                             WFB 00252900
TEXTNC   DC    AL2(DINRTMEM),AL2(1),AL2(8),CL8' '   RETURNED MEMBER WFB 00253000
TEXTNLEN EQU   *-TEXTNC                                             WFB 00253100
TEXTOC   DC    AL2(DINRTORG),AL2(1),AL2(2),XL2'0000' RETURNED DSORG WFB 00253200
TEXTOLEN EQU   *-TEXTOC                                             WFB 00253300
*                                                                   WFB 00253400
**       VALIDITY CHECK ROUTINE FOR DESTINATION                     WFB 00253500
***                                                                 WFB 00253600
****     MAXIMUM LENGTH IS 17 CHARACTERS (ENFORCED BY PARSE)        WFB 00253700
*****    DEST(NODE.USERID) MUST HAVE 1 PERIOD, EACH NAME 1-8 CHARS  WFB 00253800
******   DEST(NAME) IF NO PERIOD, MAXIMUM LENGTH IS 8 CHARACTERS    WFB 00253900
******                                                              WFB 00254000
*****    AT ENTRY, REG 1 POINTS TO A THREE WORD LIST:               WFB 00254100
****     +0  A(SDEST)   ADDRESS OF THE PDE BUILT BY PARSE           WFB 00254200
***      +4  A(WORKAREA) ADDRESS OF USER WORK AREA FROM IKJPPL      WFB 00254300
**       +8  A(VALMSG)  =F'0', ADDRESS OF USER SUPPLIED 2ND LVL MSG WFB 00254400
*                                                                   WFB 00254500
VALDEST  CSECT ,                                                    WFB 00254600
         PUSH  USING                                                WFB 00254700
         STM   R14,R12,12(13)          SAVE PARSE REGISTERS         WFB 00254800
         LR    R12,R15                 USE REG 12 AS BASE           WFB 00254900
         USING VALDEST,R12             ESTABLISH ADDRESSABILITY     WFB 00255000
         LM    R8,R10,0(R1)            LOAD INPUT LIST VALUES       WFB 00255100
         SR    R15,R15                 ASSUME ZERO RETURN CODE      WFB 00255200
         STH   R15,NODELEN-WORKAREA(,R9)  ASSUME NOT NODE.USERID    WFB 00255300
         L     R1,0(,R8)               GET ADDRESS OF DEST          WFB 00255400
         LH    R3,4(,R8)               GET TOTAL LENGTH OF DEST     WFB 00255500
         BCTR  R3,0                    DECREMENT LENGTH FOR TRT     WFB 00255600
         EX    R3,VALTRT               LOOK FOR PERIOD OR INVALID   WFB 00255700
         BZ    VALNODOT           CC=0 NOTHING FOUND, GO CHECK LEN  WFB 00255800
         BM    VALCHECK           CC=1 FOUND IN MIDDLE, GO CHECK    WFB 00255900
         B     VALRET4            CC=2 FOUND IN LAST BYTE - INVALID WFB 00256000
VALNODOT CLI   5(R8),X'08'             NO PERIOD, LEN MUST BE 1-8   WFB 00256100
         BNH   VALRETRN                YES, OK                      WFB 00256200
         B     VALRET4                 NO, INVALID LENGTH           WFB 00256300
VALCHECK CLI   0(R1),C'.'              PERIOD FOUND ?               WFB 00256400
         BNE   VALRET4                 NO, INVALID CHARACTER        WFB 00256500
         LA    R4,0(,R1)               GET ADDRESS OF PERIOD        WFB 00256600
         SL    R4,0(,R8)               MINUS BEGIN DEST = LEN NODE  WFB 00256700
         LA    R1,1(,R1)               POINT PAST PERIOD            WFB 00256800
         SLR   R3,R4                   GET REMAINING LEN OF '.USER' WFB 00256900
         BCTR  R3,0                    DECREMENT FOR PERIOD         WFB 00257000
         EX    R3,VALTRT               LOOK FOR MORE PERIOD/INVALID WFB 00257100
         BNZ   VALRET4                 FOUND, INVALID SPECIFICATION WFB 00257200
         STH   R4,NODELEN-WORKAREA(,R9)  SAVE NODE LEN IN WORKAREA  WFB 00257300
         B     VALRETRN                DONE                         WFB 00257400
VALRET4  LA    R15,4                   SET RC 4 - INVALID DEST      WFB 00257500
VALRETRN LM    R0,R12,20(R13)          RESTORE PARSE REGISTERS      WFB 00257600
         L     R14,12(,R13)            RESTORE RETURN ADDRESS       WFB 00257700
         BR    R14                     RETURN TO PARSE              WFB 00257800
*                                                                   WFB 00257900
VALTRT   TRT   0(0,R1),VALTABLE        ** EXECUTED **               WFB 00258000
VALTABLE DC    256AL1(*-VALTABLE)      TABLE OF VALID CHARACTERS    WFB 00258100
         ORG   VALTABLE+C'$'                                        WFB 00258200
         DC    X'00'                   ALLOW $                      WFB 00258300
         ORG   VALTABLE+C'#'                                        WFB 00258400
         DC    2X'00'                  ALLOW # @                    WFB 00258500
         ORG   VALTABLE+C'A'                                        WFB 00258600
         DC    9X'00'                  ALLOW A B C D E F G H I      WFB 00258700
         ORG   VALTABLE+C'J'                                        WFB 00258800
         DC    9X'00'                  ALLOW J K L M N O P Q R      WFB 00258900
         ORG   VALTABLE+C'S'                                        WFB 00259000
         DC    8X'00'                  ALLOW S T U V W X Y Z        WFB 00259100
         ORG   VALTABLE+C'0'                                        WFB 00259200
         DC    10X'00'                 ALLOW 0 1 2 3 4 5 6 7 8 9    WFB 00259300
         ORG   ,                                                    WFB 00259400
         DROP  R12                                                  WFB 00259500
         POP   USING                                                WFB 00259600
*********************** DSECT FOR DYNAMIC WORKAREA ******************** 00259700
WORKAREA DSECT                                                          00259800
SAVEAREA DS    18F                                                      00259900
ALCSAVE  DS    12F                                                      00260000
         DS    0D                                                       00260100
DEC      DS    2F                                                       00260200
RETNCD   DS    F                                                        00260300
CONV     DS    2F                                                       00260400
IOPB     PUTLINE MF=L                                                   00260500
DAP08    DS    0F                                                       00260600
         ORG   DAP08+DAP08LEN                                           00260700
DAP18    DS    0F                                                       00260800
         ORG   DAP18+DAP18LEN                                           00260900
DAPLSECT DS    0F                                                       00261000
         ORG   DAPLSECT+DAPLLEN                                         00261100
PPLSECT  DS    0F                                                       00261200
         ORG   PPLSECT+PPLLEN                                           00261300
IOPLSECT DS    0F                                                       00261400
         ORG   IOPLSECT+IOPLLEN                                         00261500
DFPLSECT DS    4F                   SPACE FOR DFPL                 GTEL 00261600
DFPBSECT DS    5F                   SPACE FOR DFPB                 GTEL 00261700
         DS    H                    TO GET ALLIGNMENT              GTEL 00261800
DFPBDSL  DS    H                    DSNAME LENGTH                  GTEL 00261900
DFPBNAME DS    CL44                 DSNAME                         GTEL 00262000
DFPBQUA  DS    CL8                                                      00262100
ECB      DS    F                                                        00262200
PARSBACK DS    F                                                        00262300
LINE     DS    0H                                                       00262400
LENGTH   DS    H                                                        00262500
         DS    H                                                        00262600
CNTLBYTE DS    CL1                                                      00262700
DATA     DS    CL256                                                    00262800
HEADER2  DS    CL13                                              ARAMCO 00262900
DSNAME   DS    CL44                                                     00263000
OPENPRN  DS    CL1                                                      00263100
MEMNAME  DS    CL8                                                      00263200
CLOSEPRN DS    CL1                                                      00263300
VOLHEAD  DS    CL11                 C'   VOLUME: ' ON HEADING       WFB 00263400
VOLNAME  DS    CL8                                                  WFB 00263500
         ORG   DSNAME-4                                                 00263600
DSNLENP  DS    CL2                                                      00263700
DSNLEN   DS    CL2                                                      00263800
DSNBUF   DS    CL44                                                     00263900
         ORG   MEMNAME-4                                                00264000
MEMNAMEL DS    CL2                                                      00264100
         ORG                                                            00264200
HEADER   DS    CL75                 (WAS 49 BEFORE DATE)     ARAMCO WFB 00264300
         ORG   HEADER+4                                                 00264400
HDRCNTL  DS    CL1                                                      00264500
         ORG   HEADER+41                                            WFB 00264600
HDRTIME  DS    CL12                 4 BYTE PREFIX, HH:MM:SS         WFB 00264700
HDRDATE  DS    CL22                 4 BYTE PREFIX, MONTHNAME DY, YR WFB 00264800
HDRTDLEN EQU   *-HDRTIME                                            WFB 00264900
DFID     DS    CL2                                                      00265000
         ORG                                                            00265100
VOLBIT   DS    CL1                                                      00265200
VOLUME   DS    CL8                                                      00265300
UNIT     DS    CL8                  UNIT() VALID ONLY WITH VOL()    WFB 00265400
PREALDDN DS    CL8                  PREALLOCATED DDNAME(...)        WFB 00265500
NODELEN  DS    H                    LEN OF NODE IN DEST(NODE.USER)  WFB 00265600
CALLMFL  CALL  ,(,),MF=L            LIST FORM FOR CALL IKJEFLPA     WFB 00265700
MEMTABLE DS    F                                                        00265800
ENDTABLE DS    F                                                        00265900
CURRENT  DS    F                                                        00266000
PRESENT  DS    F                                                        00266100
COLUMN   DS    F                                                        00266200
XLIST    DS    F                                                        00266300
LINELEN  DS    H                                                   GTEL 00266400
VBLEN    DS    H                                                   GTEL 00266500
PAGELEN  DS    H                                                   GTEL 00266600
CCBIT    DS    CL1                                                 GTEL 00266700
ALNDSECT DS    F                                                   GTEL 00266800
RDJL     RDJFCB (,),MF=L                                                00266900
JFCBAREA DS    44F                                                      00267000
         ORG   JFCBAREA+44                                              00267100
JFCBELNM DS    CL8                                                      00267200
         ORG   JFCBAREA+86                                              00267300
JFCBIND1 DS    CL1                                                      00267400
         ORG   JFCBAREA+98                                              00267500
JFCDSRG1 DS    CL1                                                      00267600
         ORG                                                            00267700
SAVER6   DS    F                                                        00267800
SAVER2   DS    2F                                                       00267900
SAVER3   DS    2F                                                       00268000
SAVMR2   DS    2F                                                  GTEL 00268100
SAVMR6   DS    2F                                                  GTEL 00268200
SAVMR9   DS    2F                                                  GTEL 00268300
*                                                                       00268400
         PRINT NOGEN                                                    00268500
*                                                                       00268600
INPUT    DCB   DSORG=PS,MACRF=(GM),EODAD=EXITI,SYNAD=ERRI,DDNAME=PRINTI 00268700
*                                                                       00268800
OUTPUTA  DCB   DSORG=PS,MACRF=(PM),SYNAD=ERRO,DDNAME=PRINTA,RECFM=VBA, X00268900
               LRECL=256,BLKSIZE=3120                                   00269000
*                                                                       00269100
OUTPUTM  DCB   DSORG=PS,MACRF=(PM),SYNAD=ERRO,DDNAME=PRINTM,RECFM=VBM, X00269200
               LRECL=256,BLKSIZE=3120                                   00269300
*                                                                       00269400
DIRECT   DCB   DDNAME=PRINTI,DSORG=PS,MACRF=(GM),RECFM=U,BLKSIZE=256,  X00269500
               SYNAD=SERRI,EODAD=FREEBLK                                00269600
*                                                                       00269700
OPENLST  OPEN  (,),MF=L                                                 00269800
*                                                                       00269900
CLOSLST  CLOSE (,),MF=L                                                 00270000
*                                                                       00270100
*                                                                       00270200
         PRINT GEN                                                      00270300
*                                                                       00270400
RETCODE  DS    F                                                        00270500
GFPARMP  DS    F                                                        00270600
         IKJEFFGF                                                       00270700
         IKJEFFDF                                                       00270800
RBPTR    DS    F                                                        00270900
REQBLK   DS    10F                                                 GTEL 00271000
TEXTPTRS DS    16F                                             GTEL WFB 00271100
TEXTA    DS    0F                                   DDNAME              00271200
         ORG   TEXTA+TEXTALEN                                           00271300
TEXTB    DS    0F                                   SYSOUT CLASS        00271400
         ORG   TEXTB+TEXTBLEN                                           00271500
TEXTC    DS    0F                                   DESTINATION         00271600
         ORG   TEXTC+TEXTCLEN                                           00271700
TEXTE    DS    0F                                   SYSOUT COPIES       00271800
         ORG   TEXTE+TEXTELEN                                           00271900
TEXTG    DS    0F                                   FCB            GTEL 00272000
         ORG   TEXTG+TEXTGLEN                                      GTEL 00272100
TEXTH    DS    0F                                   UCB            GTEL 00272200
         ORG   TEXTH+TEXTHLEN                                      GTEL 00272300
TEXTI    DS    0F                                   FORMS          GTEL 00272400
         ORG   TEXTI+TEXTILEN                                      GTEL 00272500
TEXTJ    DS    0F                                   PROG           GTEL 00272600
         ORG   TEXTJ+TEXTJLEN                                      GTEL 00272700
TEXTK    DS    0F                                   USERID          WFB 00272800
         ORG   TEXTK+TEXTKLEN                                       WFB 00272900
TEXTL    DS    0F                                   PREALLOC DDNAME WFB 00273000
         ORG   TEXTL+TEXTLLEN                                       WFB 00273100
TEXTM    DS    0F                                   RETURNED DSNAME WFB 00273200
         ORG   TEXTM+TEXTMLEN                                       WFB 00273300
TEXTN    DS    0F                                   RETURNED MEMBER WFB 00273400
         ORG   TEXTN+TEXTNLEN                                       WFB 00273500
TEXTO    DS    0F                                   RETURNED DSORG  WFB 00273600
         ORG   TEXTO+TEXTOLEN                                       WFB 00273700
*---------------------------------------------------------------------* 00273800
*------------------------- START OF ARAMCO MOD -----------------------* 00273900
*---------------------------------------------------------------------* 00274000
SETFLAG  DS    X                                                        00274100
SETBURST EQU   1                                                        00274200
SETFLSH  EQU   2                                                        00274300
SETCHAR  EQU   4                                                        00274400
SETPRTE  SETPRT OUTPUTA,,MF=L                                           00274500
SETFLASH EQU   SETPRTE+28                                               00274600
SETCHARS EQU   SETPRTE+32                                               00274700
SETPRTEL EQU   *-SETPRTE                                                00274800
SAVEUPT  DS    X                                                        00274900
*---------------------------------------------------------------------* 00275000
*--------------------------- END OF ARAMCO MOD -----------------------* 00275100
*---------------------------------------------------------------------* 00275200
LDYNAMIC EQU   *-WORKAREA                                               00275300
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00275400
*********************** DSECT FOR RECORD MAPPING ********************** 00275500
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00275600
LINDSECT DSECT                                                          00275700
RECORD   DS    0F                                                       00275800
RECLEN   DS    H                                                        00275900
         DS    H                                                        00276000
RECCC    DS    CL1                                                      00276100
RECDATA  DS    CL32760                                              WFB 00276200
RECSIZE  EQU   *-RECORD                                             WFB 00276300
*********************** END OF RECORD MAPPING DSECT ******************* 00276400
         END                                                            00276500
/*                                                                      00276600
//*----------------------------------------------------------- ASM      00276700
//DELINK.SYSIN DD *                                                     00276801
 IKJEFLA IKJEFLPA                                                       00276901
 IKJEFLA IKJEFLPB                                                       00277001
//*----------------------------------------------------------- DELINKER 00277101
//*                                                                     00277200
//LKED.SYSIN DD *                                                       00277300
  ALIAS PRINTO                                                          00277400
  ALIAS PO                                                              00277500
  NAME PRINTOFF(R)                                                      00277600
/*                                                                      00277700
//*----------------------------------------------------------- LKED     00277800
//                                                                      00277900
